// ChildFrm.h : CChildFrame NX̃C^[tFCX
//
#pragma once

#include "ChildView.h"


class CChildFrame : public CMDIChildWnd
{
	DECLARE_DYNCREATE(CChildFrame)
public:
	CChildFrame();

// 
public:

// 
public:

// I[o[Ch
public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);

// 
public:
	// t[̃NCAg̈p̃r[
	CChildView m_wndView;
	virtual ~CChildFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

// ꂽAbZ[W蓖Ċ֐
protected:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnFileClose();	
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	DECLARE_MESSAGE_MAP()


public:
	BOOL GetEdited();
	CChildView::LPIMAGE_INFO GetImageInfo() { return m_wndView.GetImageInfo(); };
	CMBSE5E::LPHST_HISTOGRAM	GetHistData();
	CMBSE5E::LPIMAGEBAG	GetImage();
	CMGC4IZ::LPFIELD_STRINGS	GetFieldText();
	LPTSTR	GetFileName();
	void SetImage(CMBSE5E::LPIMAGEBAG lpImage);
	void SetMagnification(DOUBLE nRealMagnifications, INT nMagnifications);
	void SetEdited(BOOL bEdited);
	void SetFileName(LPCTSTR lpszFileName);
	void SetHScrollPos(UINT nSBCode);
	void SetMsgUndo(LPTSTR lpszMsg);
	void SetScrollBar();
	void SetViewInfo(CChildView::LPIMAGE_INFO lpViewInfo);
	void SetWText();	

	BOOL IsZoneClipped() { return m_wndView.IsZoneClipped(); };
	INT  GetClippingZoneStatus(){ return m_wndView.GetClippingZoneStatus(); };
	LPRECT GetClippedZone() { return m_wndView.GetClippedZone(); };
	void ClipZone(INT nType) { m_wndView.ClipZone(nType); };
	void SetClippingZoneStatus(INT nStatus) { m_wndView.SetClippingZoneStatus(nStatus); };

private:
	TCHAR m_lpszTitle[512];
	RECT m_Client;
	INT  m_nVs;
	INT  m_nHs;
	POINT m_Vo;
};
