// ChildView.h : CChildView NX̃C^[tFCX
//
#pragma once

// CChildView EBhE

class CChildView : public CWnd
{
// RXgNV
public:
	CChildView();

// 
public:

// 
public:

// I[o[Ch
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);

// 
public:
	virtual ~CChildView();

	// ꂽAbZ[W蓖Ċ֐
protected:
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnDestroy();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnPaint();
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	DECLARE_MESSAGE_MAP()

public:
	virtual BOOL Create(	LPCTSTR lpszClassName, 
							LPCTSTR lpszWindowName, 
							DWORD	dwStyle, 
					const	RECT&	rect, 
							CWnd*	pParentWnd, 
							UINT	nID, 
							CCreateContext* pContext = NULL	);

public:
	static const int UNDO_MSG_X	= 340;
	static const int UNDO_MSG_Y	= 30;

	static const int CPZ_TYPE_FREE	= 1;
	static const int CPZ_TYPE_32	= 2;
	static const int CPZ_TYPE_23	= 3;
	static const int CPZ_REMOVED	= 0; // ̈斢I
	static const int CPZ_START		= 11; // ̈Iҋ@
	static const int CPZ_CLIPPING	= 12; // ̈I
	static const int CPZ_CLIPPED	= 13; // ̈悪Iꂽ
	static const int CPZ_MOVING		= 14; // ̈ړ
	static const int CPZ_GRIP_RADIUS = 7;
	static const int CPZ_GRIP_SIDE	 = 12;

	typedef struct
	{	// Ï
		BOOL	nType;		// I
		INT		nStatus;	// 
		RECT	rcArea;		// NCAgW
		LONG	nCenterX;	// ̈̒
		LONG	nCenterY;	// ̈̒
	} CLIPPING_ZONE, *LPCLIPPING_ZONE;

	typedef struct 
	{	
		LPVOID	lpImage;	// 摜̃|C^
		INT		nWidth;		// 摜
		INT		nHeight;	// 摜
		INT		nBPP;		// 摜̃rbg
		POINT	pntVo;		// \_
	} IMAGE, *LPIMAGE;

	typedef struct
	{	// Child Window ێ
		TCHAR	szFileName[MAX_PATH];	// t@C
		TCHAR	szCreateTime[32];		// 쐬
		TCHAR	szWriteTime[32];		// XV
		TCHAR	szFileAttributes[32];	// t@C
		CMBSE5E::LPIMAGEBAG lpImageBag;		// 摜̃|C^
		INT		nWidth;					// 摜
		INT		nHeight;				// 摜
		INT		nMagWidth;				// gk摜
		INT		nMagHeight;				// gk摜
		INT		nBPP;					// 摜̃rbg
		BOOL	bEdited;				// ҏWꂽ
		INT		nMagnifications;		// {
		DOUBLE  nRealMagnifications;	// {
		INT		nExifCount;				// Exif 
		CMGC4IZ::LPFIELD_STRINGS	lpField;	// Exif 
		CMBSE5E::LPHST_HISTOGRAM		lpHistData;	// qXgO
	} IMAGE_INFO, *LPIMAGE_INFO; 


	DOUBLE GetRealMagnification() { return m_info.nRealMagnifications; };
	INT	 GetMagSize(INT nValue);
	INT	 GetRealSize(INT nValue);
	void GetAreaToErase(LPRECT lpArea);
	void GetMagSize(RECT* lprcValue);
	void GetRealSize(RECT* lprcValue);
	void SetMagnification(DOUBLE nRealMagnifications, INT nMagnifications);
	void SetMessageUndo(LPCTSTR lpszMsg);

	BOOL IsZoneClipped() { return m_ClippingZone.nStatus == CPZ_CLIPPED; };
	INT  GetClippingZoneStatus() { return m_ClippingZone.nStatus; };
	LPRECT GetClippedZone() { return &m_ClippingZone.rcArea; };
	void ClipZone(INT nType);
	void SetClippingZoneStatus(INT nStatus) { m_ClippingZone.nStatus = nStatus; };

	INT		GetHs() { return m_nHs; };			// XN[
	INT		GetVs() { return m_nVs; };			// XN[
	LPIMAGE_INFO GetImageInfo() { return &m_info; };
	LPPOINT	GetVo() { return &m_Vo; };			// \_
	void	SetHs(INT nHs) { m_nHs = nHs; };	// XN[
	void	SetVo(LPPOINT lpPoint) { CopyMemory(&m_Vo, lpPoint, sizeof(POINT)); };	// \_
	void	SetVs(INT nVs) { m_nVs = nVs; };	// XN[

	
private:
	CBitmap		m_bmpMessage;
	CBrush		m_brushRed;
	CBrush		m_hatchGray;
	CPen		m_redPen;
	CImageList  m_imgIcon;
	CFrameWnd*	m_lpParentFrame;
	CBEsergeant* m_lpBSE;
	CEsergeant*	 m_lpE;
	CM3az*		 m_lpAZ;
	CM4iz*		 m_lpIZ;
	CM4lz*		 m_lpLZ;
	
	COLORREF m_crBlack;
	COLORREF m_crRed;
	COLORREF m_crWhite;
	COLORREF m_crGray;
	RECT	 m_rcClient;
	INT		 m_nSampling;
	TCHAR	 m_szMsgUndo[256];

	INT		m_nHs;	// XN[
	INT		m_nVs;	// XN[
	POINT	m_Vo;	// \_
	IMAGE_INFO	m_info;	// 摜

	CLIPPING_ZONE	m_ClippingZone;	// Ï

	BOOL InspectPoint(POINT* lpPoint, LONG nOffsetX, LONG nOffsetY);
	BOOL InspectPoint(POINT* lpPoint, LONG nOffsetX, LONG nOffsetY, LPVOID lpReserved);
	void ClipArea();
	void DrawImageAtBSE(HDC hDC);
	void DrawImageAtE(HDC hDC);
	void DrawLine(CPaintDC* lpDC);
	void DrawIZMode(CPaintDC* lpDC);
	void DrawIcon(CPaintDC* lpDC);
	void DrawMessage(CPaintDC* lpDC);
	void DrawClippingZone(CPaintDC* lpDC);
	void GetScrollPoint(BOOL bVertical, INT* lpStart, INT* lpEnd);
	void GetViewArea(BOOL bClient, RECT* lprcView);
	void MoveZone(BOOL bStart, CPoint* lpPoint);
	void ClipZone(CPoint* lpPoint);
	void GetStep(LONG nX1, LONG nX2, LONG* lpStart, LONG* lpEnd, LONG* lpStep);
};