// DlgAbout1.cpp : t@C
//

#include "stdafx.h"
#include "TestEx.h"
#include "DlgAboutPage1.h"


// CDlgAboutPage1 _CAO

IMPLEMENT_DYNAMIC(CDlgAboutPage1, CDialog)
CDlgAboutPage1::CDlgAboutPage1(CWnd* pParent, LPVOID lpBSE, LPVOID lpE)
	: CDialog(CDlgAboutPage1::IDD, pParent)
{
	m_lpBSE = (CBEsergeant*)lpBSE;
	m_lpE  = (CEsergeant*)lpE;
}

CDlgAboutPage1::~CDlgAboutPage1()
{
}

void CDlgAboutPage1::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_ABOUT_PAGE1_LIST_VERSION, m_lstVersion);
}


BEGIN_MESSAGE_MAP(CDlgAboutPage1, CDialog)
END_MESSAGE_MAP()


// CDlgAboutPage1 bZ[W nh

BOOL CDlgAboutPage1::OnInitDialog()
{
	CDialog::OnInitDialog();

	if(m_lpE->AreYouReady() == CMGC4E::no && m_lpBSE->AreYouReady() == CMBSE5E::no)
		return TRUE;

	// o[W擾
	static const INT	nMax = 8;
#if _AMD64
	static const TCHAR	szFileName[nMax][64] = {	_T("TestEx64.exe"), 
													_T("mbster5e.dll"), 
													_T("miz4jpn.dll"), 
													_T("mgc3az.dll"), 
													_T("mgc4e.dll"), 
													_T("mgc4iz.dll"),
													_T("mgc4lz.dll"),
													_T("twain_32.dll")	};
#else
	static const TCHAR	szFileName[nMax][64] = {	_T("TestEx32.exe"),
													_T("mbster5e.dll"),
													_T("miz4jpn.dll"),
													_T("mmgic3az.dll"),
													_T("mgc4e.dll"),
													_T("mgc4iz.dll"),
													_T("mgc4lz.dll"),
													_T("twain_32.dll") };
#endif 
	TCHAR	szVersion[nMax][256];
	DWORD	dwMajor, dwMinor, dwRevision, dwBild;
	INT		nI;

	for(nI = 0; nI < nMax; nI++)
	{
		dwMajor = dwMinor = dwRevision = dwBild = 0;
	
		if(m_lpE->AreYouReady() == CMGC4E::yes)
		{
			m_lpE->eGetFileVersion(	szFileName[nI], 
									&dwMajor, &dwMinor, &dwRevision, &dwBild	);
		}
		else if(m_lpBSE->AreYouReady() == CMBSE5E::yes)
		{
			m_lpBSE->beGetFileVersion(	szFileName[nI], 
									&dwMajor, &dwMinor, &dwRevision, &dwBild	);
		}

		wsprintf(szVersion[nI], _T("%d.%d.%d.%d"), dwMajor, dwMinor, dwRevision, dwBild);
	}

	// Xgɒǉ
	m_lstVersion.InsertColumn(0, _T("t@C"), LVCFMT_LEFT, 100);
	m_lstVersion.InsertColumn(1, _T("o[W"), LVCFMT_LEFT, 250);

	INT nIndex;
	for(nI = 0; nI < nMax; nI++)
	{
		nIndex = m_lstVersion.InsertItem(0, szFileName[nI]);
		m_lstVersion.SetItemText(nIndex, 1, szVersion[nI]);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}
