#pragma once
#include "afxwin.h"
#include "afxcmn.h"


// CDlgCopy _CAO

class CDlgCopy : public CDialog
{
	DECLARE_DYNAMIC(CDlgCopy)

public:
	CDlgCopy(CWnd* pParent = NULL);   // WRXgN^
	virtual ~CDlgCopy();

// _CAO f[^
	enum { IDD = IDD_COPY };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

	DECLARE_MESSAGE_MAP()
private:
	afx_msg void OnBnClickedCancel();
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedButtonEnd();
	afx_msg void OnBnClickedButtonReset();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	virtual BOOL OnInitDialog();

public:
	static const int  NO_ADJUST	= 0;
	static const int  ADJUST	= 1;

	typedef struct 
	{
		INT		nAdjust;
		INT		nFunctions;
		DOUBLE	nMagnifications;
		INT		nDegrees;
	} COPY_VALUE, *LPCOPY_VALUE;

	void GetValue(LPCOPY_VALUE lpCopyValue);

private:
	CButton		m_btnEnd;
	CBitmap		m_bmpEnd;
	CSliderCtrl m_sldRotete;
	CSliderCtrl m_sldMag;
	CButton		m_btnMirror;
	CButton		m_btnReverse;
	CButton		m_btnSepia;
	CButton		m_btnQuality;
	CStatic		m_labMagNo;
	CStatic		m_labRotateNo;
	CStatic		m_labTitle;

	COPY_VALUE	m_CopyValue;
};
