#pragma once

#include "afxwin.h"

// CDlgHistogram _CAO

class CDlgHistogram : public CDialog
{
	DECLARE_DYNAMIC(CDlgHistogram)

public:
	CDlgHistogram(INT nHist[6][256], INT nBitPixel, CWnd* pParent = NULL);   // WRXgN^
	virtual ~CDlgHistogram();

// _CAO f[^
	enum { IDD = IDD_HISTOGRAM };

protected:
	afx_msg void OnBnClickedButtonEnd();
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedRadio(UINT nID);
	afx_msg void OnPaint();
	virtual BOOL OnInitDialog();
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	DECLARE_MESSAGE_MAP()
	
public:
	static const int COLOR_R	= 0;
	static const int COLOR_G	= 1;
	static const int COLOR_B	= 2;
	static const int COLOR_I	= 3;

private:
	CBitmap m_bmpEnd;
	CButton m_btnB;
	CButton m_btnEnd;
	CButton m_btnG;
	CButton m_btnI;
	CButton m_btnR;
	CStatic m_labBit;
	CStatic m_labMax;
	CStatic m_labMin;
	CStatic m_labTitle;

	INT	m_nHist[6][256];
	INT	m_nBitPixel;
	INT	m_nColor;	
};
