#pragma once
#include "afxcmn.h"
#include "afxwin.h"

// CDlgSlider _CAO

class CDlgSlider : public CDialog
{
	DECLARE_DYNAMIC(CDlgSlider)

public:
	CDlgSlider(	CWnd*	pParent = NULL, 
				int		nMode	= IDCANCEL,
				int		nMin	= 0, 
				int		nMax	= 100, 
				int		nStep	= 1, 
				int		nPos	= 50, 
				int		nOffset	= 0, 
				int		nFloat	= 0, 
				int		nMag	= 1, 
				LPCTSTR lpLetter= _T("Dialog\0")	);   // WRXgN^
	virtual ~CDlgSlider();

// _CAO f[^
	enum { IDD = IDD_SLIDER };

protected:
	afx_msg void OnBnClickedButtonEnd();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	virtual BOOL OnInitDialog();
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	DECLARE_MESSAGE_MAP()

public:
	static const int OK			= 0;
	static const int OKCANCEL	= 1;

	int GetValue();

private:
	int	m_nFloat;
	int	m_nMag;
	int	m_nMax;
	int	m_nMin;
	int	m_nMode;
	int	m_nOffset;
	int	m_nPos;
	int	m_nStep;
	int	m_nValue;
	TCHAR m_szLetter[64];

	CBitmap	m_bmpEnd;
	CButton m_btnCancel;
	CButton m_btnOk;
	CButton	m_btnEnd;
	CSliderCtrl m_Slider1;
	CStatic	m_labTitle;
	CStatic	m_labValue;

	void SetLavelValue();
};
