// DlgYESNO.cpp : t@C
//
#include "stdafx.h"
#include "TestEx.h"
#include "DlgYESNO.h"


// CDlgYESNO _CAO

IMPLEMENT_DYNAMIC(CDlgYESNO, CDialog)
CDlgYESNO::CDlgYESNO(INT nMode, UINT nBeep, LPCTSTR lpszMsg, CWnd* pParent /*=NULL*/)
	: CDialog(CDlgYESNO::IDD, pParent)
{
	m_lpszMsg = lpszMsg;
	m_nMode = nMode;

	// {^
	m_bmpEnd.LoadBitmap(IDB_END);

	// Beep
	MessageBeep(nBeep);
}

CDlgYESNO::~CDlgYESNO()
{
	m_bmpEnd.DeleteObject();
}

void CDlgYESNO::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_YESNO_BUTTON_END, m_btnEnd);
	DDX_Control(pDX, IDC_YESNO_STATIC_MSG, m_labMsg);
	DDX_Control(pDX, IDC_YESNO_STATIC_TITLE, m_labTitle);
	DDX_Control(pDX, IDNO, m_btnNo);
	DDX_Control(pDX, IDYES, m_btnYes);
}

BEGIN_MESSAGE_MAP(CDlgYESNO, CDialog)
	ON_BN_CLICKED(IDC_YESNO_BUTTON_END, OnBnClickedButtonEnd)
	ON_BN_CLICKED(IDNO, OnBnClickedNo)
	ON_BN_CLICKED(IDYES, OnBnClickedYes)
	ON_WM_PAINT()
END_MESSAGE_MAP()


// CDlgYESNO bZ[W nh
void CDlgYESNO::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	GetDlgItem(IDC_YESNO_STATIC_MSG)->SetWindowText(m_lpszMsg);
	// `惁bZ[W CDialog::OnPaint() ĂяoȂłB
}

BOOL CDlgYESNO::OnInitDialog()
{
	CDialog::OnInitDialog();

	if(m_nMode == OK) 
	{
		m_btnNo.SetWindowPos(NULL, 0, 0, 0, 0, SWP_HIDEWINDOW);
		m_btnYes.SetWindowPos(	&CWnd::wndTop, 
								361, 78, 0, 0, 
								SWP_SHOWWINDOW | SWP_NOSIZE	);
	}

	// {^
	m_btnEnd.SetBitmap(m_bmpEnd);
										 
	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

void CDlgYESNO::OnBnClickedButtonEnd()
{
	OnCancel();
}

void CDlgYESNO::OnBnClickedYes()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	OnOK();
}

void CDlgYESNO::OnBnClickedNo()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	OnCancel();
}