#pragma once
#include "m4e.h"

// CEsergeant R}h ^[Qbg

class CEsergeant : public CM4e
{
public:
	CEsergeant();
	virtual ~CEsergeant();


	INT  eInitialize(	TW_UINT16 twMajorNum, 
						TW_UINT16 twMinorNum,
						LPCTSTR lpszManufacturer, 
						LPCTSTR lpszProductFamily,
						LPCTSTR lpszProductName		);
	INT  eDestroy(HWND hWnd);
	INT  eScan(HWND hWnd, BOOL bADF);
	INT  eScan(HWND hWnd, BOOL bADF, CMGC4E::LPRQA_DLG_PARAMS lpDlgProcParams);
	INT  eScan(HWND hWnd, BOOL bADF, LPTSTR lpFileName);
#if _DEBUG
	INT  eScanForTest(HWND hWnd, BOOL bADF);
#endif
	INT  eXfers();
	VOID eSelectSource(HWND hWnd);


	INT   eCaptureButton(HWND hWnd);
	INT   eSave(CWnd* pWnd, LPTSTR lpszFileName);
	INT   eSaveAs(CWnd* pWnd, LPTSTR lpszFileName);
	INT	  eGetDIBSize(LPINT lpHeight, LPINT lpWidth);
	LPVOID eGetImage();
	LPVOID eLoad(CWnd* pWnd, LPTSTR lpszFileName);
	VOID  eDestroyImage();
	VOID  ePaintImage(HDC hDC, LPRECT lprctDIB, LPRECT lprctDest);
	VOID  eSetImage(LPVOID lpBitmap);

	VOID eGetClipbord(HWND hWnd);
	VOID eSetClipbord(HWND hWnd);
	
	INT  eShowDlgCaps(HWND hWnd, LPCTSTR lpszTitle);
	INT  eGetFileVersion(	LPCTSTR lpszFileName,
							DWORD*	lpdwMajor, 
							DWORD*	lpdwMinor,
							DWORD*	lpdwRevision,
							DWORD*	lpdwBild		);

private:
	TW_IDENTITY m_twAppID; // Appfs identity structure
	TW_IDENTITY m_twSourceID;

	INT OpenSourceAndManager(HWND hWnd, BOOL bADF);
	INT	SetADF();
};