// Scan.cpp : t@C
//
#include "stdafx.h"
#include "m4e.h"

// CM4e
// Ver4.1600a
CM4e::CM4e()
{
	//
	//// DLL LOAD
	//
	LPTSTR lpszE = _T("mgc4e.dll");
	DWORD  dwMajor = 0;

	m_hE = LoadLibrary(lpszE);

	if(m_hE != NULL)
	{	
		// ڑ
		CloseSource	= (LPMECLOSESOURCE)GetProcAddress(m_hE, "meCloseSource");
		ConnectTwainSession	= (LPMECONNECTTWAINSESSION)GetProcAddress(m_hE, "meConnectTwainSession");
		DisconnectTwainSession	= (LPMEDISCONNECTTWAINSESSION)GetProcAddress(m_hE, "meDisconnectTwainSession");
		OpenSource	= (LPMEOPENSOURCE)GetProcAddress(m_hE, "meOpenSource");
		RequestAcquisition	= (LPMEREQUESTACQUISITION)GetProcAddress(m_hE, "meRequestAcquisition");
		Xfers	= (LPMEXFERS)GetProcAddress(m_hE, "meXfers");

		// 
		GetTwainState = (LPMEGETTWAINSTATE)GetProcAddress(m_hE, "meGetTwainState");

		// 擾
		GetAppID = (LPMEGETAPPID)GetProcAddress(m_hE, "meGetAppID");
		
		// \[X
		EnumerateSource	= (LPMEENUMERATESOURCE)GetProcAddress(m_hE, "meEnumerateSource");
		GetDefaultSource = (LPMEGETDEFAULTSOURCE)GetProcAddress(m_hE, "meGetDefaultSource");
		GetSourceID	= (LPMEGETSOURCEID )GetProcAddress(m_hE, "meGetSourceID");
		SelectSource = (LPMESELECTSOURCE)GetProcAddress(m_hE, "meSelectSource");
		SetSourceID	= (LPMESETSOURCEID)GetProcAddress(m_hE, "meSetSourceID");
			
		// @\
		GetCapability = (LPMEGETCAPABILITY)GetProcAddress(m_hE, "meGetCapability");
		GetDefaultImageLayout = (LPMEGETDEFAULTIMAGELAYOUT)
									GetProcAddress(m_hE, "meGetDefaultImageLayout");
		GetImageLayout	= (LPMEGETIMAGELAYOUT)GetProcAddress(m_hE, "meGetImageLayout");
		GetResolution	= (LPMEGETRESOLUTION)GetProcAddress(m_hE, "meGetResolution");
		SetCapability	= (LPMESETCAPABILITY)GetProcAddress(m_hE, "meSetCapability");
		SetImageInfo	= (LPMESETIMAGEINFO)GetProcAddress(m_hE, "meSetImageInfo");
		SetImageLayout	= (LPMESETIMAGELAYOUT)GetProcAddress(m_hE, "meSetImageLayout");
		SetResolution	= (LPMESETRESOLUTION)GetProcAddress(m_hE, "meSetResolution");
		ShowDlgCaps		= (LPMESHOWDLGCAPS)GetProcAddress(m_hE, "meShowDlgCaps");
		
		// ǎ摜
		DestroyImage	= (LPMEDESTROYIMAGE)GetProcAddress(m_hE, "meDestroyImage");
		GetImage		= (LPMEGETIMAGE)GetProcAddress(m_hE, "meGetImage");
		GetImageInfo	= (LPMEGETIMAGEINFO)GetProcAddress(m_hE, "meGetImageInfo");
		SetImage		= (LPMESETIMAGE)GetProcAddress(m_hE, "meSetImage");

		//// ̑
		
		// Pʕϊ
		FIX32ToFloat	= (LPMEFIX32TOFLOAT)GetProcAddress(m_hE, "meFIX32ToFloat");
		FloatToFIX32	= (LPMEFLOATTOFIX32)GetProcAddress(m_hE, "meFloatToFIX32");
		InchToMM		= (LPMEINCHTOMM)GetProcAddress(m_hE, "meInchToMM");
		InchToTwips		= (LPMEINCHTOTWIOS)GetProcAddress(m_hE, "meInchToTwips");
		MMtoInch		= (LPMEMMTOINCH)GetProcAddress(m_hE, "meMMtoInch");
		MMToTwips		= (LPMEMMTOTWIPS)GetProcAddress(m_hE, "meMMToTwips");
		TwipsToInch		= (LPMETWIPSTOINCH)GetProcAddress(m_hE, "meTwipsToInch");
		TwipsToMM		= (LPMETWIPSTOMM)GetProcAddress(m_hE, "meTwipsToMM");

		// 摜
		GetClipbordDIB	= (LPMEGETCLIPBORDDIB)GetProcAddress(m_hE, "meGetClipbordDIB");
		GetDIBSize		= (LPMEGETDIBSIZE)GetProcAddress(m_hE, "meGetDIBSize");
		LoadImage		= (LPMELOADIMAGE)GetProcAddress(m_hE, "meLoadImage");
		PaintDIB		= (LPMEPAINTDIB)GetProcAddress(m_hE, "mePaintDIB");
		SaveImage		= (LPMESAVEIMAGE)GetProcAddress(m_hE, "meSaveImage");
		SetClipbordDIB	= (LPMESETCLIPBORDDIB)GetProcAddress(m_hE, "meSetClipbordDIB");

		// ̑
		CaptureButton	= (LPMECAPTUREBUTTON)GetProcAddress(m_hE, "meCaptureButton");
		GetFileVersion	= (LPMEGETFILEVERSION)GetProcAddress(m_hE, "meGetFileVersion");	


		GetFileVersion(CT2W(lpszE), &dwMajor, NULL, NULL, NULL);

		if(dwMajor != 4)
			UnloadDll();
	}
}

CM4e::~CM4e()
{
	UnloadDll();
}


// CM4e o֐
VOID CM4e::UnloadDll()
{
	if(m_hE) 
	{
		BOOL bR = FreeLibrary(m_hE);
		m_hE = NULL;
	}
}

INT CM4e::AreYouReady()
{
	return (m_hE != NULL)? CMGC4E::yes : CMGC4E::no;
}
