#pragma once
#include "mgc4iz.h"


// CM4iz R}h ^[Qbg
//
//	This class loads the m.magic IZ DLL. 
//	Version 3.1403a
//
class CM4iz : public CObject
{
public:
	CM4iz();
	virtual ~CM4iz();

public:
	typedef INT (CALLBACK* LPMIZINITIALIZE) (CMGC4IZ::LPINI_DATA lpInitialData);
	typedef INT (CALLBACK* LPMIZBEGIN) (INT nFunctions, LPVOID lpParams);
	typedef INT (CALLBACK* LPMIZGETFILEVERSION) (	LPCWSTR	lpszFile, 
													DWORD*	lpMajor, 
													DWORD*	lpMinor, 
													DWORD*	lpRevision, 
													DWORD*	lpBuild	);
	LPMIZINITIALIZE		InitializeIZ;
	LPMIZBEGIN			Begin;
	LPMIZGETFILEVERSION	GetFileVersion;


	int	 AreYouReady();
	int	 Initialize(LPCTSTR lpszResource, BOOL bCRC = FALSE);
	int  LoadHtmlForm(const BOOL bJpn, const int nID);
	int  UnloadResource();
	void InitializeHtmlResource( const BOOL bJpn,
								 const int nID,
								 CMGC4IZ::LPHTML_RESOURCE lpHtmlResource );
	void UnloadDll();
	
private:
	HMODULE m_hMIZ;
};
