// mb5e.cpp : t@C
//

#include "stdafx.h"
#include "mb5e.h"


// CMb5e
// Ver 5.1600a
CMb5e::CMb5e()
{
	// Booster 

	m_hBooster = LoadLibrary(_T("mbster5e.dll"));

	if(m_hBooster != NULL)
	{
		AdjustContrast = (LPMBEADJUSTCONTRAST)GetProcAddress(m_hBooster, "mbeAdjustContrast");
		AdjustGamma = (LPMBEADJUSTGAMMA)GetProcAddress(m_hBooster, "mbeAdjustGamma");
		AdjustGamma2 = (LPMBEADJUSTGAMMA2)GetProcAddress(m_hBooster, "mbeAdjustGamma2");
		AdjustQuality = (LPMBEADJUSTQUALITY)GetProcAddress(m_hBooster, "mbeAdjustQuality");
 		Decolor = (LPMBEDECOLOR)GetProcAddress(m_hBooster, "mbeDecolor");
		Copy = (LPMBECOPY)GetProcAddress(m_hBooster, "mbeCopy");
		Rotate = (LPMBEROTATE)GetProcAddress(m_hBooster, "mbeRotate");
		Filter = (LPMBEFILTER)GetProcAddress(m_hBooster, "mbeFilter");
		
		AttachImage = (LPMBEATTACHIMAGE)GetProcAddress(m_hBooster, "mbeAttachImage");
		CreateImage = (LPMBECREATEIMAGE)GetProcAddress(m_hBooster, "mbeCreateImage");
		DestroyImage = (LPMBEDESTROYIMAGE)GetProcAddress(m_hBooster, "mbeDestroyImage"); 
		DrawImage = (LPMBEDRAWIMAGE)GetProcAddress(m_hBooster, "mbeDrawImage");  
		LoadImage = (LPMBELOADIMAGE)GetProcAddress(m_hBooster, "mbeLoadImage"); 
		SaveImage = (LPMBESAVEIMAGE)GetProcAddress(m_hBooster, "mbeSaveImage");
		GetColor  = (LPMBEGETCOLOR)GetProcAddress(m_hBooster, "mbeGetColor");
		
		GetImageData = (LPMBEGETIMAGEDATA)GetProcAddress(m_hBooster, "mbeGetImageData");
		GetHistogram = (LPMBEGETHISTOGRAM)GetProcAddress(m_hBooster, "mbeGetHistogram");
		CountColor = (LPMBECOUNTCOLOR)GetProcAddress(m_hBooster, "mbeCountColor");

		ReverseAction = (LPMBEREVERSEACTION)GetProcAddress(m_hBooster, "mbeReverseAction");
		
		GetClipboardImage = (LPMBEGETCLIPBOARDIMAGE)GetProcAddress(m_hBooster, "mbeGetClipboardImage");
		SetClipboardImage = (LPMBESETCLIPBOARDIMAGE)GetProcAddress(m_hBooster, "mbeSetClipboardImage");
		
		GetFileVersion = (LPMBEGETFILEVERSION)GetProcAddress(m_hBooster, "mbeGetFileVersion");
	}
}

CMb5e::~CMb5e()
{
	UnloadDll();
}


// CMb5e o֐
void CMb5e::UnloadDll()
{
	BOOL bR = CMBSE5E::failure;

	if(m_hBooster != NULL) 
	{
		bR = FreeLibrary(m_hBooster);
	}
}

int CMb5e::AreYouReady()
{
	return (m_hBooster != NULL)? CMBSE5E::yes : CMBSE5E::no;
}