#pragma once
#include "afx.h"

// CMGC4LZ R}h ^[Qbg
//
//	mgc4lz.dll  Header Ver4.1600b
//
class CMGC4LZ : public CObject
{
public:

	//
	//// common
	//
	static const INT lzTrue = TRUE;
	static const INT lzFalse = FALSE;
	static const INT null = NULL;
	static const INT yes = TRUE;
	static const INT no = FALSE;

	static const INT success = 0;
	static const INT failure = -1;

	//
	//// mlzInitialize
	//
	typedef struct
	{
		INT	 nTimerElapse;		// J[\ʒu̎擾Ԋu
		ULONG nFunction;
	} INI_PARAMETERS, *LPINI_PARAMETERS;

	/// 
	static const INT iniTimerElapseCount = 9;
	static const INT iniTimerElapse0 = 3;
	static const INT iniTimerElapse1 = 4;
	static const INT iniTimerElapse2 = 6;
	static const INT iniTimerElapse3 = 8;
	static const INT iniTimerElapse4 = 11;
	static const INT iniTimerElapse5 = 16;
	static const INT iniTimerElapse6 = 22;
	static const INT iniTimerElapse7 = 32;
	static const INT iniTimerElapse8 = 44;
	static const INT iniTimerElapseDefault = iniTimerElapse4;
	static const INT iniTimerElapseMax = 64;
	static const INT iniTimerElapseMin = 1;

	static const ULONG iniFncCommands	= 0x000000ff;
	static const ULONG iniFncCmdMode0	= 0x00000000;
	static const ULONG iniFncCmdMode1	= 0x00000001;
	static const ULONG iniFncCmdMode2	= 0x00000002;
	static const ULONG iniFncCmdMode3	= 0x00000003;

	static const ULONG iniFncOptions	= 0xffffff00;
	static const ULONG iniFncOpt0th		= 0x00000100;	// O
	static const ULONG iniFncOptCircle	= 0x00008000;	// ~̎nʒu𔻒肷
	static const ULONG iniFncOptRedraw	= 0x08000000;	// TvO_`
	static const ULONG iniFncOptDebug	= 0x80000000;

	static const ULONG iniFncDefault  = iniFncCmdMode0;
	static const ULONG iniFncStandard = iniFncCmdMode0 | iniFncOptRedraw;

	//
	//// mlzDifferentiate
	//
	typedef double CALLBACK Formula1(double nXi, LPVOID lpParameters);

	typedef struct
	{
		double		nX;				// nX ɂl߂
		long		nZ;				// ̓_
		double		nH;				// nX ̑
		Formula1*	lpFormulaLZ;	// vZ邽߂̃R[obN֐
		LPVOID		lpParameters;	// Cӂ̃|C^
	} DIF_PARAMETERS, *LPDIF_PARAMETERS;

	/// 
	static const INT difZ2	= 2;
	static const INT difZ3	= 3;
	static const INT difZ5	= 5;
	static const INT difZ7	= 7;
	static const INT difZ9	= 9;
	static const INT difZ11	= 11;

	//
	//// mlzStart
	//
	typedef struct
	{
		long	nBottom;	// ĕ`̈ 
		long	nLeft;
		long	nRight;
		long	nTop;
		BOOL	nErase;		// wi邩ǂ
	} STR_PARAMETERS, *LPSTR_PARAMETERS;

	//
	//// mlzStop
	//

	/// ߂l
	static const INT stpErrUnderExecution	= 500;		// 
	static const INT stpErrKilledTimer		= -500;		// ^C}[sS
	static const INT stpErrBufferOverflow	= -501;		// TvOpobt@s
	static const INT stpErrTimeOut			= -502;		// Ԑ؂
	static const INT stpErrFewSamplings		= -503;		// TvOs
	static const INT stpErrChangeingPosition = -504;	// ϋɓ_ʒu
	static const INT stpErrPosition			= -505;		// n_I_ω_̈ʒu
	static const INT stpErrDistance			= -580;		// TvO_ƍœK̒lƂ̌덷傫
	static const INT stpErrCannotAnalyze	= -1001;	// ͕s\

	//
	//// mlzGetResult
	//

	// nReturn
	static const ULONG grtReturnUnderExecution		= stpErrUnderExecution;		// 
	static const ULONG grtReturnKilledTimer			= stpErrKilledTimer;		// ^C}[sS
	static const ULONG grtReturnBufferOverflow		= stpErrBufferOverflow;		// TvOpobt@s
	static const ULONG grtReturnTimeOut				= stpErrTimeOut;			// Ԑ؂
	static const ULONG grtReturnFewSamplings		= stpErrFewSamplings;		// TvOs
	static const ULONG grtReturnChangeingPosition	= stpErrChangeingPosition;	// ϋɓ_ʒu
	static const ULONG grtReturnPosition			= stpErrPosition;			// n_I_ω_̈ʒu
	static const ULONG grtReturnDistance			= stpErrDistance;			// TvO_ƍœK̒lƂ̌덷傫
	static const ULONG grtReturnCannotAnalyze		= stpErrCannotAnalyze;		// ͕s\

	// nType
	static const ULONG grtTypeEquation	= 0x000000ff;
	static const ULONG grtType0th		= 0x00000000;
	static const ULONG grtType1th		= 0x00000001;
	static const ULONG grtType2th		= 0x00000002;
	static const ULONG grtType3th		= 0x00000003;
	static const ULONG grtTypeCircle	= 0x00000080;

	static const ULONG grtTypeDivision	= 0x0000f000;
	static const ULONG grtTypeDivision1 = 0x00001000;
	static const ULONG grtTypeDivision2 = 0x00002000;
	static const ULONG grtTypeDivision3 = 0x00003000;

	static const ULONG grtType0A = 0x00000000;
	static const ULONG grtType0B = 0x00000100;
	static const ULONG grtType0C = 0x00000200;
	static const ULONG grtType0D = 0x00000300;
	static const ULONG grtType1A = 0x00000001;
	static const ULONG grtType1B = 0x00000101;
	static const ULONG grtType1C = 0x00000201;
	static const ULONG grtType1D = 0x00000301;
	static const ULONG grtType2A = 0x00000002;
	static const ULONG grtType2B = 0x00000102;
	static const ULONG grtType2C = 0x00000202;
	static const ULONG grtType2D = 0x00000302;
	static const ULONG grtType2E = 0x00000402;
	static const ULONG grtType2F = 0x00000502;
	static const ULONG grtType2G = 0x00000602;
	static const ULONG grtType2H = 0x00000702;
	static const ULONG grtType3A = 0x00000003;
	static const ULONG grtType3B = 0x00000103;
	static const ULONG grtType3C = 0x00000203;
	static const ULONG grtType3D = 0x00000303;
	static const ULONG grtType3E = 0x00000403;
	static const ULONG grtType3F = 0x00000503;
	static const ULONG grtType3G = 0x00000603;
	static const ULONG grtType3H = 0x00000703;
	static const ULONG grtTypeCircleRight = 0x00000080;	// E]	
	static const ULONG grtTypeCircleRightTop = 0x00001080;	// E]An_
	static const ULONG grtTypeCircleRightBottom = 0x00002080;	// E]An_ 
	static const ULONG grtTypeCircleLeft = 0x00000480;	// ]
	static const ULONG grtTypeCircleLeftTop = 0x00001480;	// ]An_
	static const ULONG grtTypeCircleLeftBottom = 0x00002480;	// ]An_

	static const ULONG grtTypeOther = 0x000000ff;
	static const ULONG grtTypeError = 0xffffffff;

	typedef struct
	{
		INT		nResultNo;			// s
		INT		nReturn;			// s
		INT 	nType;				// J[\OՂ̎
		INT		nChangingCount;		// ω_
		INT		nSamplingCount;		// J[\W̕W{
		INT		nRotated;			// W]ǂ
		double	nCoefficient[8];	// W
	} GRT_RESULT, *LPGRT_RESULT;

	//
	//// mlzGetSamplingPosition
	//
	typedef struct
	{
		INT		nResultNo;			// s
		INT		nCount;				// ݂̕W{
		INT		nChangingPosition;	// W{ω_ǂ
		POINT	ptSamplingPosition;	// W{W
	} GSP_PARAMETERS, *LPGSP_PARAMETERS;

};