//
//// mmgic3az.dll  Header Ver3.1305a
//
//   (C) m.magic & K Maruyama.  All rights reserved.

#pragma once
//
//// 
//

// 萔
#define MAZ_NULL		NULL
#define MAZ_MAX_PATH	MAX_PATH
#define MAZ_YES			TRUE
#define MAZ_NO			FALSE
#define MAZ_OK			1
#define MAZ_CANCEL		0

// ߂l
#define MAZ_SUCCESS		0
#define MAZ_FAILURE		-1
#define MAZ_TRUE		1
#define MAZ_FALSE		0

//
////  fBXN
//
//* mazGetDriveType *//
// 萔
#define MAZ_DRIVE_UNKNOWN		DRIVE_UNKNOWN		//The drive type cannot be determined.
#define MAZ_DRIVE_NO_ROOT_DIR	DRIVE_NO_ROOT_DIR	//The root path is invalid. For example, no volume is mounted at the path. 
#define MAZ_DRIVE_REMOVABLE		DRIVE_REMOVABLE		//The disk can be removed from the drive. 
#define MAZ_DRIVE_FIXED			DRIVE_FIXED			//The disk cannot be removed from the drive. 
#define MAZ_DRIVE_REMOTE		DRIVE_REMOTE		//The drive is a remote (network) drive. 
#define MAZ_DRIVE_CDROM			DRIVE_CDROM			//The drive is a CD-ROM drive. 
#define MAZ_DRIVE_RAMDISK		DRIVE_RAMDISK		//The drive is a RAM disk. 
//* mazGetLogicalDrives *//
#define MAZ_DRIVE_A 0x0000001
#define MAZ_DRIVE_B 0x0000002
#define MAZ_DRIVE_C 0x0000004
#define MAZ_DRIVE_D 0x0000008
#define MAZ_DRIVE_E 0x0000010
#define MAZ_DRIVE_F 0x0000020
#define MAZ_DRIVE_G 0x0000040
#define MAZ_DRIVE_H 0x0000080
#define MAZ_DRIVE_I 0x0000100
#define MAZ_DRIVE_J 0x0000200
#define MAZ_DRIVE_K 0x0000400
#define MAZ_DRIVE_L 0x0000800
#define MAZ_DRIVE_M 0x0001000
#define MAZ_DRIVE_N 0x0002000
#define MAZ_DRIVE_O 0x0004000
#define MAZ_DRIVE_P 0x0008000
#define MAZ_DRIVE_Q 0x0010000
#define MAZ_DRIVE_R 0x0020000
#define MAZ_DRIVE_S 0x0040000
#define MAZ_DRIVE_T 0x0080000
#define MAZ_DRIVE_U 0x0100000
#define MAZ_DRIVE_V 0x0200000
#define MAZ_DRIVE_W 0x0400000
#define MAZ_DRIVE_X 0x0800000
#define MAZ_DRIVE_Y 0x1000000
#define MAZ_DRIVE_Z 0x2000000
//* mazGetVolumeInformation *//
// 萔
#define MAZ_GVI_CASE_IS_PRESERVED		FS_CASE_IS_PRESERVED			// t@CL^ƂɁA啶Əʂĕۑ܂B 
#define MAZ_GVI_CASE_SENSITIVE			FS_CASE_SENSITIVE				// t@C̑啶Ə̋ʂT|[gĂ܂B 
#define MAZ_GVI_UNICODE_STORED_ON_DISK	FS_UNICODE_STORED_ON_DISK		// Unicode ̃t@CT|[gĂāAfBXNł\܂B 
#define MAZ_GVI_PERSISTENT_ACLS			FS_PERSISTENT_ACLS				// ACLiANZX䃊Xgj̕ۑƓKps܂B 
#define MAZ_GVI_FILE_COMPRESSION		FS_FILE_COMPRESSION				// t@Cx[ẌkT|[gĂ܂B 
#define MAZ_GVI_VOL_IS_COMPRESSED		FS_VOL_IS_COMPRESSED			// k{[łB 
#define MAZ_GVI_NAMED_STREAMS			FILE_NAMED_STREAMS				// OtXg[T|[gĂ܂B 
#define MAZ_GVI_SUPPORTS_ENCRYPTION		FILE_SUPPORTS_ENCRYPTION		// Ít@CVXeiEFSjT|[gĂ܂B 
#define MAZ_GVI_SUPPORTS_OBJECT_IDS		FILE_SUPPORTS_OBJECT_IDS		// IuWFNgʎqT|[gĂ܂B 
#define MAZ_GVI_SUPPORTS_REPARSE_POINTS FILE_SUPPORTS_REPARSE_POINTS	// ĉ̓|CgT|[gĂ܂B 
#define MAZ_GVI_SUPPORTS_SPARSE_FILES	FILE_SUPPORTS_SPARSE_FILES		// aȃt@CAgp̗̈悪A܂͓lt@CT|[gĂ܂B 
#define MAZ_GVI_VOLUME_QUOTAS			FILE_VOLUME_QUOTAS				// fBXNNH[^T|[gĂ܂B 
// ^
typedef struct 
{
	TCHAR	szVolumeName[256];
	DWORD	dwVolumeSerialNumber;
	DWORD	dwMaximumComponentLength;
	DWORD	dwFileSystemFlags;
	TCHAR	szSystemName[256];
} MAZ_GVI_VOLUME_INFORMATION, *LPMAZ_GVI_VOLUME_INFORMATION;

//
//// VXe
//
//* mazGetWinVersion *//
#define MAZ_GWV_PLATFORM_WIN32s			VER_PLATFORM_WIN32s			// Win32s on Windows 3.1. 
#define MAZ_GWV_PLATFORM_WIN32_WINDOWS	VER_PLATFORM_WIN32_WINDOWS	// Windows 95, Windows 98, or Windows Me. 
#define MAZ_GWV_PLATFORM_WIN32_NT		VER_PLATFORM_WIN32_NT
//* mazGetCpuInformations *//
// 
#define MAZ_GCI_DO_NOT_WRITE_TO_FILE	NULL
#define MAZ_GCI_MAX_VNAME_LEN			14
#define MAZ_GCI_MAX_MNAME_LEN			50
#define MAZ_GCI_MAX_STANDERD_COUNT		64
#define MAZ_GCI_MAX_EXTENDED_COUNT		64
// register
#define MAZ_GCI_EAX		0
#define MAZ_GCI_EBX		1
#define MAZ_GCI_ECX		2
#define MAZ_GCI_EDX		3
// 3d commands
#define MAZ_GCI_FEATURE_MMX			0x000100
#define MAZ_GCI_FEATURE_MMX_EXT		0x000200
#define MAZ_GCI_FEATURE_SSE			0x000400
#define MAZ_GCI_FEATURE_SSE2		0x000800
#define MAZ_GCI_FEATURE_SSE3		0x001000
#define MAZ_GCI_FEATURE_SSE4_1		0x002000
#define MAZ_GCI_FEATURE_SSE4_2		0x004000
#define MAZ_GCI_FEATURE_3DNOW		0x000001
#define MAZ_GCI_FEATURE_3DNOW_EXT	0x000002
#define MAZ_GCI_FEATURE_SSE4_A		0x000004
// Virtual Machine
#define MAZ_GCI_FEATURE_AMD_V		0x010000 
#define MAZ_GCI_FEATURE_INTEL_VT	0x020000 
// 64-bit technology available 
#define MAZ_GCI_FEATURE_X64			0x040000 
// ߂l
#define MAZ_GCI_ERR_NOT_SUPPORTED	 10000
#define MAZ_GCI_ERR_FILE			-10000
#define MAZ_GCI_ERR_OUTPUT_BUFFER	-10001
// ^
typedef struct
{
	INT nValue[4];
} MAZ_GCI_CPUID, *PMAZ_GCI_CPUID; 

typedef struct
{
	INT				nSize;	// size of this structure
	MAZ_GCI_CPUID	cidStandard[MAZ_GCI_MAX_STANDERD_COUNT];
	MAZ_GCI_CPUID	cidExtended[MAZ_GCI_MAX_EXTENDED_COUNT];	
} MAZ_GCI_INFORMATION_A, *PMAZ_GCI_INFORMATION_A;

typedef struct
{
	INT		nSize;									// size of this structure
	FLOAT	nFrequency;								// frequency(MHz)
	CHAR	szVendorName[MAZ_GCI_MAX_VNAME_LEN];	// vendor name
	CHAR	szModelName[MAZ_GCI_MAX_MNAME_LEN];		// name of model
	INT		nFamily;								// family of the processor
	INT		nExtendedFamily;						// extended family of the processor
	INT		nBaseFamily;							// base family of the processor
	INT		nModel;									// model of the processor
	INT		nExtendedModel;							// extended model of the processor
	INT		nBaseModel;								// base model of the processor
	INT		nStepping;								// the processor revision number
	INT		nCores;									// the processor count 
	INT		nLogicalCores;							// the logical processor count 
	INT		nThreads;								// Thread count
	INT		nFeature;								// the processor feature
} MAZ_GCI_INFORMATION_B, *PMAZ_GCI_INFORMATION_B;

//
//// t@C
//
//* mazGetFileVersionEx *//
// 
#define MAZ_GFV_FILE_VERSION_SIZE MAX_PATH;
 
// ^
typedef struct
{
	DWORD dwMajor;
	DWORD dwMinor;
	DWORD dwRevision;
	DWORD dwBild;
	DWORD dwLength;				// szFilePath ̃TCY	
	TCHAR szFilePath[MAX_PATH];	// lo[W̃t@CpX
} MAZ_GFV_FILE_VERSION, *LPMAZ_GFV_FILE_VERSION;
//* mazShowDirListBox *//
// 
#define MAZ_SDB_TYPE_A	BIF_RETURNONLYFSDIRS | BIF_BROWSEFORCOMPUTER | BIF_DONTGOBELOWDOMAIN
#define MAZ_SDB_TYPE_B	MAZ_SDB_TYPE_A | BIF_NEWDIALOGSTYLE | BIF_NONEWFOLDERBUTTON
#define MAZ_SDB_TYPE_C	MAZ_SDB_TYPE_A | BIF_NEWDIALOGSTYLE 
// ^
typedef struct 
{
	HWND	hWnd;
	UINT	nStyle;
	INT		nX;
	INT		nY;
	INT		nWidth;
	INT		nHeight;
	LPCSTR lpszMessage;
	LPCSTR lpszCurrentDirectory;
	INT		nReserved;
} MAZ_SDB_INFORMATION, *LPMAZ_SDB_INFORMATION;
//* mazGetSpecialFolderPath *//
// 萔
#define MAZ_SFP_ADMINTOOLS				CSIDL_ADMINTOOLS		
#define MAZ_SFP_APPDATA					CSIDL_APPDATA			 
#define MAZ_SFP_ADMINTOOLS				CSIDL_ADMINTOOLS		
#define MAZ_SFP_COMMON_APPDATA			CSIDL_COMMON_APPDATA	
#define MAZ_SFP_COMMON_DESKTOPDIRECTORY	CSIDL_COMMON_DESKTOPDIRECTORY
#define MAZ_SFP_COMMON_DOCUMENTS 		CSIDL_COMMON_DOCUMENTS 		
#define MAZ_SFP_COMMON_FAVORITES 		CSIDL_COMMON_FAVORITES 		
#define MAZ_SFP_COMMON_MUSIC 			CSIDL_COMMON_MUSIC 		
#define MAZ_SFP_COMMON_PICTURES 		CSIDL_COMMON_PICTURES 	
#define MAZ_SFP_COMMON_PROGRAMS			CSIDL_COMMON_PROGRAMS	
#define MAZ_SFP_COMMON_STARTMENU 		CSIDL_COMMON_STARTMENU 	
#define MAZ_SFP_COMMON_STARTUP 			CSIDL_COMMON_STARTUP 	
#define MAZ_SFP_COMMON_TEMPLATES 		CSIDL_COMMON_TEMPLATES 	
#define MAZ_SFP_COOKIES 				CSIDL_COOKIES 			
#define MAZ_SFP_DESKTOP 				CSIDL_DESKTOP 			
#define MAZ_SFP_DESKTOPDIRECTORY 		CSIDL_DESKTOPDIRECTORY
#define MAZ_SFP_FAVORITES 				CSIDL_FAVORITES 		
#define MAZ_SFP_FONTS 					CSIDL_FONTS 			
#define MAZ_SFP_HISTORY 				CSIDL_HISTORY 		
#define MAZ_SFP_INTERNET_CACHE 			CSIDL_INTERNET_CACHE
#define MAZ_SFP_LOCAL_APPDATA 			CSIDL_LOCAL_APPDATA 
#define MAZ_SFP_MYMUSIC 				CSIDL_MYMUSIC 		
#define MAZ_SFP_MYPICTURES 				CSIDL_MYPICTURES 	
#define MAZ_SFP_MYVIDEO 				CSIDL_MYVIDEO 		
#define MAZ_SFP_PERSONAL 				CSIDL_PERSONAL 		
#define MAZ_SFP_PROGRAM_FILES 			CSIDL_PROGRAM_FILES 		
#define MAZ_SFP_PROGRAM_FILES_COMMON 	CSIDL_PROGRAM_FILES_COMMON 	
#define MAZ_SFP_PROGRAMS 				CSIDL_PROGRAMS 			
#define MAZ_SFP_RECENT 					CSIDL_RECENT 			
#define MAZ_SFP_STARTMENU 				CSIDL_STARTMENU 		
#define MAZ_SFP_STARTUP 				CSIDL_STARTUP 			
#define MAZ_SFP_SYSTEM 					CSIDL_SYSTEM 			
#define MAZ_SFP_TEMPLATES 				CSIDL_TEMPLATES 		
#define MAZ_SFP_WINDOWS 				CSIDL_WINDOWS 
//* mazGetFileAttributes & mazSetFileAttributes *//
// 萔
#define MAZ_ATR_ARCHIVE				FILE_ATTRIBUTE_ARCHIVE			// A[JCut@C܂̓A[JCufBNgłB 
#define	MAZ_ATR_COMPRESSED			FILE_ATTRIBUTE_COMPRESSED		// t@C܂̓fBNg͈kĂ܂B 
#define MAZ_ATR_DEVICE				FILE_ATTRIBUTE_DEVICE			// \ς݁BgȂłB 
#define MAZ_ATR_DIRECTORY			FILE_ATTRIBUTE_DIRECTORY		// fBNgB 
#define MAZ_ATR_ENCRYPTED			FILE_ATTRIBUTE_ENCRYPTED		// t@C܂̓fBNg͈ÍĂ܂B 
#define MAZ_ATR_HIDDEN				FILE_ATTRIBUTE_HIDDEN			// Bt@C܂͉BfBNgłB 
#define MAZ_ATR_NORMAL				FILE_ATTRIBUTE_NORMAL			//t@C܂̓fBNgɂ́Aɑ͂܂B 
#define MAZ_ATR_NOT_CONTENT_INDEXED FILE_ATTRIBUTE_NOT_CONTENT_INDEXED // Windows 2000FCfbNXT[rX̑ΏۂɂȂĂ܂B 
#define MAZ_ATR_OFFLINE				FILE_ATTRIBUTE_OFFLINE			// Windows 2000F̃t@C̃f[^́Aɂ͗pł܂B 
#define MAZ_ATR_READONLY			FILE_ATTRIBUTE_READONLY			// t@C܂̓fBNg͓ǂݎpłB 
#define MAZ_ATR_REPARSE_POINT		FILE_ATTRIBUTE_REPARSE_POINT	// ĉ̓|Cg֘AtĂ܂B 
#define MAZ_ATR_SPARSE_FILE			FILE_ATTRIBUTE_SPARSE_FILE		// aȃt@CAgp̗̈悪A܂͓lt@CłB 
#define MAZ_ATR_SYSTEM				FILE_ATTRIBUTE_SYSTEM			// t@C܂̓fBNǵAIy[eBOVXepłB 
#define MAZ_ATR_TEMPORARY			FILE_ATTRIBUTE_TEMPORARY 
//* mazGetWindowsPath *//
// 
#define MAZ_GWP_WINDOWS_PATH		1
#define MAZ_GWP_SYSTEM_PATH			2
//* mazGetFileTime & mazSetFileTime *//
// 
#define MAZ_FTM_TIME_KIND			0x00ff
#define MAZ_FTM_CREATE_TIME			0x0001
#define MAZ_FTM_ACCESS_TIME			0x0002
#define MAZ_FTM_WRITE_TIME			0x0004
//* mazSearchDirectory *//
// 
#define MAZ_SDR_SEARCH_OPTIONS		0x00ff
#define MAZ_SDR_SEARCH				0x0000
#define MAZ_SDR_NO_SUBDIR			0x0000
#define MAZ_SDR_INCLUDE_SUBDIR		0x0001
#define MAZ_SDR_NO_DIR_NAME			0x0000
#define MAZ_SDR_INCLUDE_DIR_NAME	0x0002
#define MAZ_SDR_ATTRIBUTES_TYPE		0xff00
#define MAZ_SDR_NORMAL_ATTRIBUTES	0x0000
#define MAZ_SDR_INCLUDE_ARCHIVE		0x0100
#define MAZ_SDR_INCLUDE_HIDDEN		0x0200
#define MAZ_SDR_INCLUDE_READONLY	0x0400
#define MAZ_SDR_INCLUDE_SYSTEM		0x0800
// ߂l
#define MAZ_SDR_ERR_OPENING_FILE	-200
#define MAZ_SDR_ERR_CANCEL			-201
// R[obN֐
#define MAZ_SDR_BEGINE_PROCESS		0
#define MAZ_SDR_END_PROCESS			-1000000
// ^
typedef BOOL CALLBACK MAZDIRSEARCHAZ (	const	INT		nNumber, 
												LPCSTR lpszFileName, 
										const	DWORD	dwAttributes, 
										const	LPVOID	lpParams	);

typedef struct 
{
	MAZDIRSEARCHAZ	*lpProcess;		// R[obN֐̃|C^	
	LPVOID			lpParams;		// ėp|C^ĩ|C^́AR[obN֐ɂ̂܂ܓnj
} MAZ_SDR_DIRECTORY_SEARCH, *LPMAZ_SDR_DIRECTORY_SEARCH;

//
//// [
//
//* mazBitArray *//
#define MAZ_BAR_ALLOCATE_MEMORY		1
#define MAZ_BAR_SET_BIT				2
#define MAZ_BAR_RESET_BIT			3
#define MAZ_BAR_GET_BIT				4
#define MAZ_BAR_DELETE_PAGE			5
#define MAZ_BAR_DELETE_ALL_PAGE		6
//* mazQueue *//
// 
#define MAZ_QUE_TYPE					0x00ff
#define MAZ_QUE_COMMAND					0xff00
#define MAZ_QUE_COMMAND_NUMBER          0xe000
#define MAZ_QUE_COMMAND_ONE             0x0000

#define MAZ_QUE_TYPE_INT32				0x0000
#define MAZ_QUE_TYPE_INT16				0x0001
#define MAZ_QUE_TYPE_INT64				0x0002
#define MAZ_QUE_TYPE_BYTE				0x0003
#define MAZ_QUE_TYPE_FLOAT				0x0004
#define MAZ_QUE_TYPE_DOUBLE				0x0005
#define MAZ_QUE_TYPE_CONTAINER_A		0x0006
#define MAZ_QUE_TYPE_CONTAINER_B		0x0007	// new type
#define MAZ_QUE_CMD_CREATE				0x0000
#define MAZ_QUE_CMD_DESTROY				0x0100
#define MAZ_QUE_CMD_POP					0x0200
#define MAZ_QUE_CMD_PUSH				0x0300
#define MAZ_QUE_CMD_PEEK				0x0400
#define MAZ_QUE_CMD_DELCONTAINER		0x0500
#define MAZ_QUE_CMD_GETCOUNT			0x0600
#define MAZ_QUE_CMD_CONTAINES			0x0700
#define MAZ_QUE_CMD_ENUMERATE_BEGINNING	0x0800
#define MAZ_QUE_CMD_ENUMERATE			0x0900
// ߂l
#define MAZ_QUE_ERR_MEMORY			-100
#define MAZ_QUE_EMPTY				-3
#define MAZ_QUE_FULL				-2
#define MAZ_QUE_FAILURE				-1
#define MAZ_QUE_CONTAINED			1
#define MAZ_QUE_NOT_CONTAINED		2
// ^
typedef struct
{	// L[ / X^bN \z
	INT nValueType;			// f[^^
	INT nDepth;				// ő[
} MAZ_QUE_CREATE,  *LPMAZ_QUE_CREATE, 
  MAZ_STK1_CREATE, *LPMAZ_STK1_CREATE,
  MAZ_STK2_CREATE, *LPMAZ_STK2_CREATE;
typedef struct
{	// L[IuWFNg
	INT		nDepth;			// ő[
	INT		nValueType;		// f[^^
	LPVOID	lpQueue;		// L[̃|C^
} MAZ_QUE_QUEUE, *LPMAZ_QUE_QUEUE;
typedef struct
{	// f[^Rei
	INT		nSize;			// lpParams ̃TCY
	BOOL    bGlobalPointer;	// lpParams ̓O[o
	LPVOID	lpParams;		//
} MAZ_QUE_CONTAINER_A,  *LPMAZ_QUE_CONTAINER_A,
  MAZ_STK1_CONTAINER_A, *LPMAZ_STK1_CONTAINER_A;
typedef struct
{	// f[^Rei
	INT		nSize;		// lpParams ̃TCY
	LPVOID	lpParams;	
} MAZ_QUE_CONTAINER_B,  *LPMAZ_QUE_CONTAINER_B,
  MAZ_STK1_CONTAINER_B, *LPMAZ_STK1_CONTAINER_B,
  MAZ_STK2_CONTAINER,   *LPMAZ_STK2_CONTAINER;
//* mazStack *//
// 
#define MAZ_STK1_TYPE					MAZ_QUE_TYPE
#define MAZ_STK1_COMMAND				MAZ_QUE_COMMAND
#define MAZ_STK1_COMMAND_NUMBER			MAZ_QUE_COMMAND_NUMBER
#define MAZ_STK1_COMMAND_ONE 			0x0000

#define MAZ_STK1_TYPE_INT32				MAZ_QUE_TYPE_INT32
#define MAZ_STK1_TYPE_INT16				MAZ_QUE_TYPE_INT16
#define MAZ_STK1_TYPE_INT64				MAZ_QUE_TYPE_INT64
#define MAZ_STK1_TYPE_BYTE				MAZ_QUE_TYPE_BYTE
#define MAZ_STK1_TYPE_FLOAT				MAZ_QUE_TYPE_FLOAT
#define MAZ_STK1_TYPE_DOUBLE			MAZ_QUE_TYPE_DOUBLE
#define MAZ_STK1_TYPE_CONTAINER_A		MAZ_QUE_TYPE_CONTAINER_A
#define MAZ_STK1_TYPE_CONTAINER_B		MAZ_QUE_TYPE_CONTAINER_B
#define MAZ_STK1_CMD_CREATE				MAZ_QUE_CMD_CREATE
#define MAZ_STK1_CMD_DESTROY			MAZ_QUE_CMD_DESTROY
#define MAZ_STK1_CMD_POP				MAZ_QUE_CMD_POP
#define MAZ_STK1_CMD_PUSH				MAZ_QUE_CMD_PUSH
#define MAZ_STK1_CMD_PEEK				MAZ_QUE_CMD_PEEK
#define MAZ_STK1_CMD_DELCONTAINER		MAZ_QUE_CMD_DELCONTAINER

#define MAZ_STK2_TYPE					MAZ_QUE_TYPE
#define MAZ_STK2_COMMAND				MAZ_QUE_COMMAND
#define MAZ_STK2_COMMAND_NUMBER			MAZ_QUE_COMMAND_NUMBER
#define MAZ_STK2_COMMAND_TWO			0x2000

#define MAZ_STK2_TYPE_INT32				 MAZ_QUE_TYPE_INT32
#define MAZ_STK2_TYPE_INT16				 MAZ_QUE_TYPE_INT16
#define MAZ_STK2_TYPE_INT64				 MAZ_QUE_TYPE_INT64
#define MAZ_STK2_TYPE_BYTE				 MAZ_QUE_TYPE_BYTE
#define MAZ_STK2_TYPE_FLOAT				 MAZ_QUE_TYPE_FLOAT
#define MAZ_STK2_TYPE_DOUBLE			 MAZ_QUE_TYPE_DOUBLE
#define MAZ_STK2_TYPE_CONTAINER			 MAZ_QUE_TYPE_CONTAINER_B
#define MAZ_STK2_CMD_CREATE				 0x2000
#define MAZ_STK2_CMD_DESTROY			 0x2100
#define MAZ_STK2_CMD_POP				 0x2200
#define MAZ_STK2_CMD_PUSH				 0x2300
#define MAZ_STK2_CMD_PEEK				 0x2400
#define MAZ_STK2_CMD_BACK				 0x2500
#define MAZ_STK2_CMD_ENUMERATE_BEGINNING 0x2600
#define MAZ_STK2_CMD_ENUMERATE			 0x2700
// ߂l
#define MAZ_STK1_ERR_MEMORY		MAZ_QUE_ERR_MEMORY
#define MAZ_STK1_FAILURE		MAZ_QUE_FAILURE
#define MAZ_STK2_ERR_MEMORY		MAZ_QUE_ERR_MEMORY
#define MAZ_STK2_FAILURE		MAZ_QUE_FAILURE
// ^
typedef struct
{	// X^bNIuWFNg
	INT		nDepth;			// ő[
	INT		nValueType;		// f[^^
	LPVOID	lpStack;		// X^bÑ|C^
} MAZ_STK1_STACK, *LPMAZ_STK1_STACK, MAZ_STK2_STACK, *LPMAZ_STK2_STACK;

//
//// WXg
//
//* mazGetRegData & mazSetRegData *//
// 
// dwFunction
#define MAZ_REG_READ			2
#define MAZ_REG_READ_SIZE		3
// nKey
#define MAZ_REG_ROOT				1
#define MAZ_REG_CURRENT_CONFIG		2
#define MAZ_REG_CURRENT_USER		3
#define MAZ_REG_LOCAL_MACHINE		4
#define MAZ_REG_USER				5
#define MAZ_REG_DYN_DATA			6
#define MAZ_REG_PERFORMANCE_DATA	7
#define MAZ_REG_PERFORMANCE_NLSTEXT	8
#define MAZ_REG_PERFORMANCE_TEXT	9



// dwType
#define MAZ_REG_SZ			1
#define MAZ_REG_BINARY		3
#define MAZ_REG_DWORD		4
#define MAz_REG_QWORD		11

//
//// k/L
//
//* mazCompress & mazExpand *//
// 
#define MAZ_CMP_MODE		0x000f
#define MAZ_CMP_OPTION		0x0ff0
#define MAZ_CMP_MODE_4096	0x0002
#define MAZ_CMP_MODE_8192	0x0003	
#define MAZ_CMP_MODE_16384	0x0004
#define MAZ_CMP_MODE_32768	0x0005	
#define MAZ_CMP_MODE_65536	0x0006
#define MAZ_CMP_OPTION_DIFF	0x0010
// ^
typedef struct
{
	DWORD  dwRules;		// k@
	ULONG  nSize;		// f[^TCY
	ULONG  nCmpSize;	// kf[^TCY
	LPVOID lpCmpData;   // kf[^
} MAZ_CMP_PACK_LZ, *LPMAZ_CMP_PACK_LZ;
//* mazDecordByHuffman & mazEncodeByHuffman *//
// ^
typedef struct
{
	ULONG  nSize;		// f[^TCY
	ULONG  nCmpSize;	// kf[^TCY
	ULONG  nFreqSize;	// opx\TCY
	LPVOID lpFreq;		// opx\
	LPVOID lpCmpData;	// kf[^
}  MAZ_CMP_PACK_HUFF, *LPMAZ_CMP_PACK_HUFF;	

//
//// /l ϊ
//
#define MAZ_CDS_E	0
#define MAZ_CDS_F	1
#define MAZ_CDS_G	2
#define MAZ_CDS_A	3

//
//// ̑
//
//* mazGetTime *//
// 
#define MAZ_GTM_SYSTEM_TIME	0x0
#define MAZ_GTM_LOCAL_TIME	0x1
