Option Strict Off
Option Explicit On 

Imports System.Runtime.InteropServices

Module mbster5e

    '///
    '//// Booster E DLL Header Ver 5.1600a
    '//
    '///  (C) m.magic & K Maruyama. All rights reserved.

    '//
    '//// ʒl
    '//
    Public Const mbeTrue As Integer = 1
    Public Const mbeFalse As Integer = 0
    Public Const mbeNull As Integer = 0
    Public Const mbeYes As Integer = True
    Public Const mbeNo As Integer = False
    Public Const mbeMaxPath As Integer = 260

    Public Const mbeColorRGB As Integer = 0 '// ԗΐ
    Public Const mbeColorR As Integer = 1 '// 
    Public Const mbeColorG As Integer = 2 '// 
    Public Const mbeColorB As Integer = 3 '// 
    Public Const mbeColorI As Integer = 4 '// Px
    Public Const mbeColorH As Integer = 5 '// F
    Public Const mbeColorS As Integer = 6 '// ʓx
    Public Const mbeBaseColor As Integer = &HF

    Public Const mbeBPP1 As Integer = 1
    Public Const mbeBPP4 As Integer = 4
    Public Const mbeBPP8 As Integer = 8
    Public Const mbeBPP24 As Integer = 24

    Public Const mbeForImageProsessing As Integer = &HF0000000
    Public Const mbePushInReverseBuffer As Integer = &H0
    Public Const mbeDoNotPushInReverseBuffer As Integer = &H80000000 '// Reverse Buffer  Push Ȃ 
    Public Const mbeNoReverseBuffer As Integer = &H0
    Public Const mbeReverseBuffer As Integer = &H10000000     '// + Reverse Buffer

    '//
    '//// ʖ߂l
    '//
    Public Const mbeSuccess As Integer = 0
    Public Const mbeFailure As Integer = -1
    Public Const mbeCanceled As Integer = 1

    Public Const mbeErrCannotDecolor As Integer = -550 '// FłȂ
    Public Const mbeErrFile As Integer = -551           '// t@CQ
    Public Const mbeErrIndexed As Integer = -552        '// CfbNXJ[͏łȂ
    Public Const mbeErrMemory As Integer = -553         '// [s
    Public Const mbeErrRVA As Integer = -554            '// o[Xobt@

    '//
    '//// ʍ\
    '//
    Structure MBE_REVERSE_BUFFER
        Dim stack As Integer    '// o[Xobt@
        Dim count As Integer    '// ot@Ă鑍
        Dim redo As Integer     '// hDł鐔
    End Structure

    Structure MBE_COLOR_PALET
        Dim r As Integer
        Dim g As Integer
        Dim b As Integer
    End Structure

    Structure MBE_IMAGEBAG '// 摜
        Dim image As Integer
        Dim reverseBuffer As MBE_REVERSE_BUFFER
    End Structure

    '//
    '//// \p
    '//
    Structure MBE_DISPLAY_PARAMS
        Dim status As Integer
        Dim maxCount As Integer
        Dim count As Integer
        Dim params As Integer
    End Structure

    '// R[obN֐
    Public Const mbeDisplayAdjustContrast As Integer = 1
    Public Const mbeDisplayAdjustGamma As Integer = 2
    Public Const mbeDisplayAdjustGamma2 As Integer = 3
    Public Const mbeDisplayAdjustQuality As Integer = 4
    Public Const mbeDisplayCopy As Integer = 5
    Public Const mbeDisplayCountColor As Integer = 6
    Public Const mbeDisplayDecolor As Integer = 7
    Public Const mbeDisplayFilter As Integer = 8
    Public Const mbeDisplayGetHistogram As Integer = 9
    Public Const mbeDisplayRotate As Integer = 10

    Public Delegate Function MBEDISPLAYFUNCTION(ByRef params As MBE_DISPLAY_PARAMS) As Integer

    Structure MBE_CALLBACK_PARAMS
        Dim callbackFunction As MBEDISPLAYFUNCTION
        Dim params As Integer
    End Structure


    '//* mbeCreateImage *//
    '// 
    Public Const mbeCriNoReverseBuffer As Integer = &H0
    Public Const mbeCriReverseBuffer As Integer = &H10000000  '// + Reverse Buffer


    '//* mbeSaveImage *//
    '// 
    Public Const mbeSavType As Integer = &HFF
    Public Const mbeSavOption As Integer = &HFF00
    Public Const mbeSavBMP As Integer = &H0
    Public Const mbeSavGIF As Integer = &H2
    Public Const mbeSavJPG As Integer = &H4
    Public Const mbeSavPNG As Integer = &H5
    Public Const mbeSavTIF As Integer = &H6
    '// Options ->	
    Public Const mbeSavDontRename As Integer = &H100
    '// <-


    '//* mbeLoadImage *//
    '// 
    Public Const mbeLdiNoReverseBuffer As Integer = mbeNoReverseBuffer
    Public Const mbeLdiReverseBuffer As Integer = mbeReverseBuffer  '// + Reverse Buffer

    '// R[obN֐
    Public Delegate Function MBEJPEGFUNCTION(ByRef quality As Integer, ByVal pParams As IntPtr) As Integer

    Structure MBE_JPEG_PROCESS
        Dim jpegFunction As MBEJPEGFUNCTION
        Dim params As Integer
    End Structure


    '//* mbeAttachImage *//
    '// 
    Public Const mbeAtiNoReverseBuffer As Integer = mbeNoReverseBuffer
    Public Const mbeAtiReverseBuffer As Integer = mbeReverseBuffer  '// + Reverse Buffer


    '//* mbeGetClipboardImage *//
    '// 
    Public Const mbecpiNoReverseBuffer As Integer = mbeNoReverseBuffer
    Public Const mbecpiReverseBuffer As Integer = mbeReverseBuffer  '// + Reverse Buffer


    '//* mbeReverseAction *//
    '// 
    Public Const mbeRvaUndo As Integer = 1
    Public Const mbeRvaRedo As Integer = 2
    '// ߂l
    Public Const mbeRvaAdjustContrast As Integer = 1
    Public Const mbeRvaAdjustGamma As Integer = 2
    Public Const mbeRvaAdjustGamma2 As Integer = 3
    Public Const mbeRvaAdjustQuality As Integer = 4
    Public Const mbeRvaAttach As Integer = 5
    Public Const mbeRvaCopy As Integer = 6
    Public Const mbeRvaDecolor As Integer = 7
    Public Const mbeRvaFilter As Integer = 8
    Public Const mbeRvaGetClipboardImage As Integer = 9
    Public Const mbeRvaLoadImage As Integer = 10
    Public Const mbeRvaRotate As Integer = 11


    '///
    '//////	image processing functions
    '//
    '//

    '//* mbeDecolor *//
    Public Const mbeDecValue As Integer = &HFF        '// l
    Public Const mbeDecMode As Integer = &HFF00
    Public Const mbeDecModeA As Integer = &H100      '// 24bit
    Public Const mbeDecModeB As Integer = &H200      '// Level
    Public Const mbeDecModeC As Integer = &H300      '// fBAJbg@
    Public Const mbeDecModeD As Integer = &H400      '// 2bit
    Public Const mbeDecBase As Integer = &HF0000
    Public Const mbeDecBaseRGB As Integer = &H0      '// ϓ
    Public Const mbeDecBaseR As Integer = &H10000    '// 
    Public Const mbeDecBaseG As Integer = &H20000    '// 
    Public Const mbeDecBaseB As Integer = &H30000    '// 
    Public Const mbeDecBaseI As Integer = &H40000    '// Px
    Public Const mbeDecOption As Integer = &HFF00000
    Public Const mbeDecOp666 As Integer = &H0        '// 8bit(6,6,6)
    Public Const mbeDecOp884 As Integer = &H100000   '// 8bit(8,4,4)
    Public Const mbeDecOp667 As Integer = &H200000   '// 8bit(6,6,7)
    Public Const mbeDecOpCOLOR As Integer = &H0
    Public Const mbeDecOpGRAY As Integer = &H400000
    Public Const mbeDecOp1bit As Integer = &H0        '// mCYȂ
    Public Const mbeDecOp1bitPlusNoise As Integer = &H100000   '// mCYt


    '//* mbeAdjustContrast *//
    '// 
    Public Const mbeAdcBaseColor As Integer = mbeBaseColor
    Public Const mbeAdcR As Integer = mbeColorR     '// 
    Public Const mbeAdcG As Integer = mbeColorG     '// 
    Public Const mbeAdcB As Integer = mbeColorB     '// 
    Public Const mbeAdcRGB As Integer = mbeColorRGB '// ԗΐ
    Public Const mbeAdcCommand As Integer = &HFF
    Public Const mbeAdcAdjustAuto As Integer = &H0
    Public Const mbeAdcAdjustManual As Integer = &H1
    Public Const mbeAdcAdjustSpot As Integer = &H2

    '// \
    Structure MBE_ADC_ADJUSTMENT
        Dim level As Integer
        Dim baseColor As Integer
        Dim left As Integer
        Dim top As Integer
        Dim right As Integer
        Dim bottom As Integer
    End Structure


    '//* mbeAdjustGamma *//
    '// 
    Public Const mbeAdgR As Integer = mbeColorR   '// 
    Public Const mbeAdgG As Integer = mbeColorG   '// 
    Public Const mbeAdgB As Integer = mbeColorB   '// 
    Public Const mbeAdgRGB As Integer = mbeColorRGB '// ԗΐ
    Public Const mbeAdgConstantI As Integer = &H100 '// Px

    '// \
    Structure MBE_ADG_ADJUSTMENT
        Dim gamma As Double
        Dim baseColor As Integer
        Dim left As Integer
        Dim top As Integer
        Dim right As Integer
        Dim bottom As Integer
    End Structure


    '//* mbeAdjustGamma2 *//
    '// \
    <StructLayout(LayoutKind.Sequential)> Structure MBE_ADG_ADJUSTMENT2
        <VBFixedArray(255), MarshalAs(UnmanagedType.ByValArray, SizeConst:=256)> _
        Public mappingData() As Byte
        Public baseColor As Integer
        Public left As Integer
        Public top As Integer
        Public right As Integer
        Public bottom As Integer
        Public Sub Initialize()
            ReDim mappingData(255)
        End Sub
    End Structure

    '//* mbeAdjustQuality *//
    '// 
    Public Const mbeAdqCommand As Integer = &HFF
    Public Const mbeAdqOptions As Integer = &HFFFFFF00
    Public Const mbeAdqCmdQuality As Integer = &H0
    Public Const mbeAdqOptAll As Integer = &H0
    Public Const mbeAdqOptFarDistance As Integer = &H100

    '// \
    Structure MBE_ADQ_ADJUSTMENT
        Dim heu As Integer
        Dim intensity As Integer
        Dim saturation As Integer
        Dim color As Integer
        Dim colorDistance As Integer
        Dim left As Integer
        Dim top As Integer
        Dim right As Integer
        Dim bottom As Integer
    End Structure


    '//* mbeCopy *// 
    '// 
    Public Const mbeCpyCommand As Integer = &HFF
    Public Const mbeCpyOption As Integer = &HFFFFFF00
    Public Const mbeCpyCopy As Integer = &H0
    Public Const mbeCpyAnd As Integer = &H1             '// AND COPY
    Public Const mbeCpyOr As Integer = &H2              '// OR COPY
    Public Const mbeCpyXor As Integer = &H3             '// XOR COPY
    Public Const mbeCpyGetSize As Integer = &H4         '// TCY擾
    Public Const mbeCpyMHQ As Integer = &H0             '// gkRs[i High
    Public Const mbeCpyMLQ As Integer = &H100           '// gkRs[i Low
    Public Const mbeCpyMirror As Integer = &H200        '// ~[]
    Public Const mbeCpyReverseColor As Integer = &H400  '// F̃rbg]
    Public Const mbeCpySepia As Integer = &H800         '// ZsAJ[

    Public Const mbeCpyNoReverseBuffer As Integer = mbeNoReverseBuffer
    Public Const mbeCpyReverseBuffer As Integer = mbeNoReverseBuffer '// + Reverse Buffer

    '// \
    Structure MBE_CPY_PARAMS
        Dim srcLeft As Integer     '// \[XʒuTCY
        Dim srcTop As Integer
        Dim srcRight As Integer
        Dim srcBottom As Integer
        Dim bitPerPixel As Integer '// F
        Dim degrees As Integer     '// ]p
        Dim magX As Single         '// {
        Dim magY As Single
        Dim destX As Integer       '// o͈ʒuTCY
        Dim destY As Integer
        Dim destWidth As Integer
        Dim destHeight As Integer
    End Structure


    '//*  mbeFilter +Ver4.1500 *//
    '// 
    Public Const mbefltFILTER As Integer = &HF
    Public Const mbefltTYPE As Integer = &HFFF
    Public Const mbefltOPTIONS As Integer = &HFFFF000

    Public Const mbefltHIGHPASS As Integer = &H0
    Public Const mbefltLOWPASS As Integer = &H1

    '// HighpassFilter
    '// 
    Public Const mbeFltPrewitX As Integer = &H0
    Public Const mbeFltPrewitY As Integer = &H10
    Public Const mbeFltPrewitXY As Integer = &H20
    Public Const mbeFltSobelX As Integer = &H30
    Public Const mbeFltSobelY As Integer = &H40
    Public Const mbeFltSobelXY As Integer = &H50
    Public Const mbeFltSharpening1 As Integer = &H60
    Public Const mbeFltSharpening2 As Integer = &H70
    Public Const mbeFltSharpening3 As Integer = &H80
    Public Const mbeFltSharpening4 As Integer = &H90
    Public Const mbeFltSharpening5 As Integer = &HA0
    Public Const mbeFltSharpening6 As Integer = &HB0
    Public Const mbeFltSharpening7 As Integer = &HC0
    Public Const mbeFltSharpening8 As Integer = &HD0
    Public Const mbeFltCustom As Integer = &HFF0
    '// Option
    Public Const mbeFltColor As Integer = &H0
    Public Const mbeFltReverse As Integer = &H1000
    Public Const mbeFltGray As Integer = &H2000
    Public Const mbeFltBlackWhite32 As Integer = &H4000
    Public Const mbeFltBlackWhite64 As Integer = &H8000
    Public Const mbeFltBlackWhite128 As Integer = &H10000
    Public Const mbeFltBlackWhite160 As Integer = &H20000
    Public Const mbeFltBlackWhite192 As Integer = &H40000
    Public Const mbeFltBlackWhite224 As Integer = &H80000
    '// LowpassFilter
    '// 
    Public Const mbeFltMedianFilter As Integer = &H1
    Public Const mbeFltMoovingAverage1 As Integer = &H11
    Public Const mbeFltMoovingAverage2 As Integer = &H21
    Public Const mbeFltMoovingAverage3 As Integer = &H31
    Public Const mbeFltMoovingAverage4 As Integer = &H41

    '// \
    <StructLayout(LayoutKind.Sequential)> Structure MBE_FLT_CUSTOM_DATA
        <VBFixedArray(24), MarshalAs(UnmanagedType.ByValArray, SizeConst:=25)> _
        Dim filter() As Integer    '// tB^
        Dim ordinal As Integer     '// tB^̏
        Dim offset As Integer      '// F̃ItZbg
        Dim xy As Integer          '// wƂx܂߂
        '̍\̂̃CX^Xɂ́A"Initialize" ĂяoȂ΂Ȃ܂B
        Public Sub Initialize()
            ReDim filter(24)
        End Sub
    End Structure

    Structure MBE_FLT_ADJUSTMENT
        Dim left As Integer
        Dim top As Integer
        Dim right As Integer
        Dim bottom As Integer
        Dim filter As MBE_FLT_CUSTOM_DATA
        Public Sub Initialize()
            left = right = top = bottom = 0
            filter.Initialize()
        End Sub
    End Structure


    '//* Rotate *//
    Public Const mbeRotMHQ As Integer = mbeCpyMHQ
    Public Const mbeRotMLQ As Integer = mbeCpyMLQ

    Structure MBE_ROT_PARAMS
        Dim degrees As Integer   '// ]p
    End Structure


    '//* mbeGetHistogram *//
    '// \
    '// hist[HstR][] ͐ hist[HstG][]͗ ȉ Hst* ƓSUF nPeakDensity 
    '// 
    Public Const mbeHstR As Integer = 0   '// 
    Public Const mbeHstG As Integer = 1   '// 
    Public Const mbeHstB As Integer = 2   '// 
    Public Const mbeHstI As Integer = 3   '// Px
    Public Const mbeHstH As Integer = 4   '// F
    Public Const mbeHstS As Integer = 5   '// ʓx

    Public Structure MBE_HST_HISTOGRAM
        <VBFixedArray(1535), MarshalAs(UnmanagedType.ByValArray, SizeConst:=1536)> Dim data() As Integer
        <VBFixedArray(5), MarshalAs(UnmanagedType.ByValArray, SizeConst:=6)> Dim peakDensity() As Integer
        <VBFixedArray(5), MarshalAs(UnmanagedType.ByValArray, SizeConst:=6)> Dim maxmum() As Integer
        Dim bitPerPixel As Integer

        '̍\̂̃CX^Xɂ́A"Initialize" ĂяoȂ΂Ȃ܂B
        Public Sub Initialize()
            ReDim data(1535)
            ReDim maxmum(5)
            ReDim peakDensity(5)
        End Sub
    End Structure


    '//
    '////  VB p
    '//
    Public Const mbeBLACKNESS As Integer = &H42S       'ׂĂ̏o͂ɂ܂B
    Public Const mbeDSTINVERT As Integer = &H550009    ']̃rbg}bv𔽓]܂B
    Public Const mbeMERGECOPY As Integer = &HC000CA    'p^[ rbg}bvƓ]rbg}bv_ AND ZqŌ܂B
    Public Const mbeMERGEPAINT As Integer = &HBB0226   ']]rbg}bvƓ]rbg}bv_ OR ZqŌ܂B
    Public Const mbeNOTSRCCOPY As Integer = &H330008   ']]rbg}bv]rbg}bvɃRs[܂B
    Public Const mbeNOTSRCERASE As Integer = &H1100A6  ']rbg}bvƓ]rbg}bv_ OR ZqŌʂ𔽓]܂B
    Public Const mbePATCOPY As Integer = &HF00021      'p^[ rbg}bv]rbg}bvɃRs[܂B
    Public Const mbePATINVERT As Integer = &H5A0049    'p^[ rbg}bvƓ]rbg}bv_ XOR ZqŌ܂B
    Public Const mbePATPAINT As Integer = &HFB0A09     ']]rbg}bvƃp^[ rbg}bv_ OR ZqŌ܂BɁȂœ̂Ɠ]rbg}bv_ OR ZqŌ܂B
    Public Const mbeSRCAND As Integer = &H8800C6       ']̃rbg}bvƓ]rbg}bṽsNZ_ AND ZqŌ܂B
    Public Const mbeSRCCOPY As Integer = &HCC0020      ']rbg}bv]rbg}bvɃRs[܂B
    Public Const mbeSRCERASE As Integer = &H440328     ']rbg}bv𔽓]ǍʂƓ]rbg}bv_ AND ZqŌ܂B
    Public Const mbeSRCINVERT As Integer = &H660646    ']rbg}bṽsNZƓ]rbg}bv_ XOR ZqŌ܂B
    Public Const mbeSRCPAINT As Integer = &HEE0086     ']rbg}bṽsNZƓ]rbg}bv_ OR ZqŌ܂B
    Public Const mbeWHITENESS As Integer = &HFF0062    'ׂĂ̏o͂𔒂ɂ܂


    '//
    '//// ֐錾
    '//
    Public Declare Unicode Function _
    mbeAdjustContrast Lib "mbster5e.dll" (ByVal pWnd As IntPtr, _
                                          ByVal functions As Integer, _
                                          ByRef adjustment As MBE_ADC_ADJUSTMENT, _
                                          ByVal pImage As IntPtr, _
                                          ByRef cbParams As MBE_CALLBACK_PARAMS) As Integer
    Public Declare Unicode Function _
    mbeAdjustContrast Lib "mbster5e.dll" (ByVal pWnd As IntPtr, _
                                          ByVal functions As Integer, _
                                          ByRef adjustment As MBE_ADC_ADJUSTMENT, _
                                          ByVal pImage As IntPtr, _
                                          ByVal pCbParams As IntPtr) As Integer
    Public Declare Unicode Function _
    mbeAdjustGamma Lib "mbster5e.dll" (ByVal pWnd As IntPtr, _
                                       ByVal functions As Integer, _
                                       ByRef lpAdjustment As MBE_ADG_ADJUSTMENT, _
                                       ByVal pImage As IntPtr, _
                                       ByRef params As MBE_CALLBACK_PARAMS) As Integer
    Public Declare Unicode Function _
    mbeAdjustGamma Lib "mbster5e.dll" (ByVal pWnd As IntPtr, _
                                       ByVal functions As Integer, _
                                       ByRef lpAdjustment As MBE_ADG_ADJUSTMENT, _
                                       ByVal pImage As IntPtr, _
                                       ByVal pParams As IntPtr) As Integer
    Public Declare Unicode Function _
    mbeAdjustQuality Lib "mbster5e.dll" (ByVal pWnd As IntPtr, _
                                         ByVal functions As Integer, _
                                         ByRef adjustment As MBE_ADQ_ADJUSTMENT, _
                                         ByVal pImage As IntPtr, _
                                         ByRef params As MBE_CALLBACK_PARAMS) As Integer
    Public Declare Unicode Function _
    mbeAdjustQuality Lib "mbster5e.dll" (ByVal pWnd As IntPtr, _
                                         ByVal functions As Integer, _
                                         ByRef adjustment As MBE_ADQ_ADJUSTMENT, _
                                         ByVal pImage As IntPtr, _
                                         ByVal pParams As IntPtr) As Integer
    Public Declare Unicode Function _
    mbeCopy Lib "mbster5e.dll" (ByVal pWnd As IntPtr, _
                                ByVal functions As Integer, _
                                ByRef params As MBE_CPY_PARAMS, _
                                ByVal pOriginal As IntPtr, _
                                ByVal pCopy As IntPtr, _
                                ByRef params As MBE_CALLBACK_PARAMS) As Integer
    Public Declare Unicode Function _
    mbeCopy Lib "mbster5e.dll" (ByVal pWnd As IntPtr, _
                                ByVal functions As Integer, _
                                ByRef params As MBE_CPY_PARAMS, _
                                ByVal pOriginal As IntPtr, _
                                ByVal pCopy As IntPtr, _
                                ByVal pParams As IntPtr) As Integer
    Public Declare Unicode Function _
    mbeDecolor Lib "mbster5e.dll" (ByVal pWnd As IntPtr, _
                                   ByVal functions As Integer, _
                                   ByVal pImage As IntPtr, _
                                   ByVal pNewImage As IntPtr, _
                                   ByRef pParams As MBE_CALLBACK_PARAMS) As Integer
    Public Declare Unicode Function _
    mbeDecolor Lib "mbster5e.dll" (ByVal pWnd As IntPtr, _
                                   ByVal functions As Integer, _
                                   ByVal pImage As IntPtr, _
                                   ByVal pNewImage As IntPtr, _
                                   ByVal pParams As IntPtr) As Integer
    Public Declare Unicode Function _
    mbeFilter Lib "mbster5e.dll" (ByVal pWnd As IntPtr, _
                                  ByVal functions As Integer, _
                                  ByRef adjustment As MBE_FLT_ADJUSTMENT, _
                                  ByVal pImage As IntPtr, _
                                  ByRef params As MBE_CALLBACK_PARAMS) As Integer
    Public Declare Unicode Function _
    mbeFilter Lib "mbster5e.dll" (ByVal pWnd As IntPtr, _
                                  ByVal functions As Integer, _
                                  ByRef adjustment As MBE_FLT_ADJUSTMENT, _
                                  ByVal pImage As IntPtr, _
                                  ByVal pParams As IntPtr) As Integer
    Public Declare Unicode Function _
    mbeRotate Lib "mbster5e.dll" (ByVal pWnd As IntPtr, _
                                  ByVal functions As Integer, _
                                  ByRef params As MBE_ROT_PARAMS, _
                                  ByVal pImage As IntPtr, _
                                  ByRef params As MBE_CALLBACK_PARAMS) As Integer
    Public Declare Unicode Function _
    mbeRotate Lib "mbster5e.dll" (ByVal pWnd As IntPtr, _
                                  ByVal functions As Integer, _
                                  ByRef params As MBE_ROT_PARAMS, _
                                  ByVal pImage As IntPtr, _
                                  ByVal pParams As IntPtr) As Integer

    Public Declare Unicode Function _
    mbeAttachImage Lib "mbster5e.dll" (ByVal functions As Integer, _
                                       ByVal pBitmap As IntPtr) As IntPtr
    Public Declare Unicode Function _
    mbeCreateImage Lib "mbster5e.dll" (ByVal functions As Integer, _
                                       ByVal width As Integer, _
                                       ByVal height As Integer, _
                                       ByVal BPP As Integer, _
                                       ByVal flags As Integer) As IntPtr
    Public Declare Unicode Function _
    mbeDestroyImage Lib "mbster5e.dll" (ByVal pImage As IntPtr) As Integer
    Public Declare Unicode Function _
    mbeDrawImage Lib "mbster5e.dll" (ByVal pDestDC As IntPtr, _
                                     ByVal xDest As Integer, _
                                     ByVal yDest As Integer, _
                                     ByVal destWidth As Integer, _
                                     ByVal destHeight As Integer, _
                                     ByVal xSrc As Integer, _
                                     ByVal ySrc As Integer, _
                                     ByVal ROP As Integer, _
                                     ByVal pSrcImage As IntPtr) As Integer
    Public Declare Unicode Function _
    mbeLoadImage Lib "mbster5e.dll" (ByVal functions As Integer, _
                                     ByVal fileName As String) As IntPtr
    Public Declare Unicode Function _
    mbeSaveImage Lib "mbster5e.dll" (ByVal functions As Integer, _
                                     ByVal pImage As IntPtr, _
                                     ByVal fileName As String, _
                                     ByRef jpeg As MBE_JPEG_PROCESS) As Integer

    Public Declare Unicode Function _
    mbeGetImageData Lib "mbster5e.dll" (ByVal pImage As IntPtr, _
                                        ByRef width As Integer, _
                                        ByRef height As Integer, _
                                        ByRef BPP As Integer) As Integer
    Public Declare Unicode Function _
    mbeGetHistogram Lib "mbster5e.dll" (ByVal pWnd As IntPtr, _
                                        ByVal pImage As IntPtr, _
                                        ByRef histData As MBE_HST_HISTOGRAM, _
                                        ByRef params As MBE_CALLBACK_PARAMS) As Integer
    Public Declare Unicode Function _
    mbeCountColor Lib "mbster5e.dll" (ByVal pWnd As IntPtr, _
                                      ByVal functions As Integer, _
                                      ByVal pImage As IntPtr, _
                                      ByRef params As MBE_CALLBACK_PARAMS) As Integer


    Public Declare Unicode Function _
    mbeGetColor Lib "mbster5e.dll" (ByVal image As Integer, _
                                    ByVal x As Integer, _
                                    ByVal y As Integer) As Integer


    Public Declare Unicode Function _
    mbeReverseAction Lib "mbster5e.dll" (ByVal functions As Integer, _
                                         ByVal lpBuffer As IntPtr) As Integer

    Public Declare Unicode Function _
    mbeSetClipboardImage Lib "mbster5e.dll" (ByVal pWnd As IntPtr, _
                                             ByVal pImage As IntPtr) As Integer
    Public Declare Unicode Function _
    mbeGetClipboardImage Lib "mbster5e.dll" (ByVal functions As Integer, _
                                             ByVal pWnd As IntPtr) As IntPtr


    Public Declare Unicode Function _
    mbeGetFileVersion Lib "mbster5e.dll" (ByVal fileName As String, _
                                          ByRef major As Integer, _
                                          ByRef minor As Integer, _
                                          ByRef revision As Integer, _
                                          ByRef build As Integer, _
                                          ByVal reserved As Integer) As Integer

End Module