using System;
using System.Runtime.InteropServices;
using twain;

namespace m4e
{
	/// <summary>
	//
	// m.magic E DLL Header Ver4.1600a
	//
	//  (C) m.magic & K Maruyama. All rights reserved.
	/// </summary>
	public class me
	{
		//  萔
		public const int eTrue = 1;
		public const int eFalse = 0;
		public const int eYes = 1;
		public const int eNo = 0;
		public const int eNull = 0;
		public const int maxPath = 260;

		// meOpenSource
        public const uint osoSourceManeger = 0x00000001;	// Open data source maneger
        public const uint osoSource = 0x00000002;  			// Open data source
        public const uint osoCheckTurningOn = 0x00010000;   // Check turning on
        public const uint osoShowErrorMessage = 0x00020000; // Show message dialog
        public const uint osoAuto3 = osoSource | osoSourceManeger;
        public const uint osoAuto2 = osoAuto3 | osoShowErrorMessage;
        public const uint osoAuto1 = osoAuto2 | osoCheckTurningOn;

		public const int osoTurningOff = 1000;

		// meCloseSource
		public const uint csoAUTO = osoAuto2;
		public const uint csoSourceManeger = osoSourceManeger;
		public const uint csoSource = osoSource;
		public const uint csoShowErrorMessage = osoShowErrorMessage;


		// meRequestAcquisition
		public const uint rqaTmCommand = 0x000000ff;
		public const uint rqaTmNative = 0x00000000;
		public const uint rqaTmMemory = 0x00000001;
		public const uint rqaTmDisk = 0x00000002;
		public const uint rqaUiShow = 0x00000000;
		public const uint rqaUiHide = 0x00000100;

		public const uint rqaTimeoutNo = 0xf0000000;
		public const uint rqaTimeout0 = 0x00000000;
		public const uint rqaTimeout1 = 0x10000000;
		public const uint rqaTimeout2 = 0x20000000;
		public const uint rqaTimeout3 = 0x30000000;
		public const uint rqaTimeout4 = 0x40000000;
		public const uint rqaTimeout5 = 0x50000000;
		public const uint rqaTimeout6 = 0x60000000;
		public const uint rqaTimeout7 = 0x70000000;
		public const uint rqaTimeout8 = 0x80000000;
		public const uint rqaTimeout9 = 0x90000000;
		public const uint rqaTimeoutA = 0xa0000000;
		public const uint rqaTimeoutB = 0xb0000000;
		public const uint rqaTimeoutC = 0xc0000000;
		public const uint rqaTimeoutD = 0xd0000000;
		public const uint rqaTimeoutE = 0xe0000000;
		
		public delegate int MECALLBACKFUNCTION(	IntPtr 	pDialog , 
												int 	maxSize, 
												int 	writtenSize, 
												String 	text		);

		public struct RQA_DLG_PARAMS
		{
			// R[obN֐pf[^ 
			public MECALLBACKFUNCTION function;    // R[obN֐
			public int parameters;			   // _CAÕ|C^
			public int maxSize;					   // 鑍oCg
			public int writtenSize;				   // oCg
			[MarshalAs(UnmanagedType.ByValTStr, SizeConst = maxPath)]
			public String text;					// Cӂ̕
		}
		
		// meXfers
        public const int xfrContinue = 0;		// ǎp
        public const int xfrAborted = 1;		// I
        public const int xfrEND = xfrAborted;	
        public const int xfrDone = 2;			// ǎ芮Aǉ摜
        public const int xfrFinished = 3;		// ǎ芮Aǉ摜Ȃ
        public const int xfrLast = xfrFinished;
        public const int xfrTimeout = 4;		// Ԑ؂

		// meGetCapability & meSetCapability
		public const int capRangeMin = 0;
		public const int capRangeMax = 1;
		public const int capRangeStep = 2;
		public const int capMaxArray = 512;

        // meSaveImage
        public const int sviDontOverWrite = 0;
        public const int sviCreateFile = 1;

        // meGetWindowsDirectory
        public const int gwdWindowsDirectory = 0;
        public const int gwdSystemDirectory = 1;
	

		//^
		public struct POINT
		{
			public int x;
			public int y;
		}

		public struct  MSG
		{
			public IntPtr pWnd;
			public int message;
			public int wParam;
			public int lParam;
			public int time;
			public POINT pt; 
		}

		public struct  RECT
		{
			public int left;
			public int top;
			public int right;
			public int bottom;
		}


		//
		//// TWAIN
		//

		// ڑ
		[DllImport("mgc4e.dll")]
		public static extern int meCloseSource(uint function, IntPtr pWnd);
		[DllImport("mgc4e.dll", CharSet = CharSet.Unicode)]
		public static extern int meConnectTwainSession(ref tw.TW_IDENTITY twAppID, string SMDirectory);
		[DllImport("mgc4e.dll")]
		public static extern int meConnectTwainSession(ref tw.TW_IDENTITY twAppID, IntPtr pSMDirectory);
		[DllImport("mgc4e.dll")]
		public static extern int meDisconnectTwainSession ();
		[DllImport("mgc4e.dll")]
		public static extern int meOpenSource (uint function,  IntPtr pWnd);
		[DllImport("mgc4e.dll")]
		public static extern int meRequestAcquisition (uint function,  IntPtr pWnd, ref int parameters);
		[DllImport("mgc4e.dll")]
		public static extern int meRequestAcquisition (uint function,  IntPtr pWnd, ref RQA_DLG_PARAMS dlgProcParams);
		[DllImport("mgc4e.dll", CharSet = CharSet.Unicode)]
		public static extern int meRequestAcquisition (uint function,  IntPtr pWnd, string fileName);
		[DllImport("mgc4e.dll")]
		public static extern int meRequestAcquisition (uint function,  IntPtr pWnd, int parameters);
		[DllImport("mgc4e.dll")]
		public static extern int meXfers ();

		// 
		[DllImport("mgc4e.dll")]
		public static extern short meGetTwainState ();

		// 擾
		[DllImport("mgc4e.dll")]
		public static extern int meGetAppID (ref tw.TW_IDENTITY twAppID);

		// \[X
		[DllImport("mgc4e.dll")]
		public static extern int meEnumerateSource (int reset);
		[DllImport("mgc4e.dll")]
		public static extern int meGetDefaultSource (ref tw.TW_IDENTITY sourceID);
		[DllImport("mgc4e.dll")]
		public static extern int meGetSourceID (ref tw.TW_IDENTITY sourceID);
		[DllImport("mgc4e.dll")]
		public static extern int meSelectSource ();
		[DllImport("mgc4e.dll")]
		public static extern int meSetSourceID (ref tw.TW_IDENTITY sourceID);


		//
		//// @\
		//

		// Capability
		[DllImport("mgc4e.dll")]
		public static extern int meGetCapability (  ushort twMsg, 
                                                    ushort twCap,
                                                    ref ushort twConType, 
                                                    ref ushort twItemType,
                                                    ref int capsArray,
                                                    ref int twMaxSize,
                                                    int errorMessage    );
		[DllImport("mgc4e.dll")]
		public static extern int meGetCapability (  ushort twMsg,
                                                    ushort twCap,
                                                    ref ushort twConType,
                                                    ref ushort twItemType,
                                                    ref short capsArray,
                                                    ref int twMaxSize,
                                                    int errorMessage    );
		[DllImport("mgc4e.dll")]
		public static extern int meGetCapability (  ushort twMsg,
                                                    ushort twCap,
                                                    ref ushort twConType,
                                                    ref ushort twItemType,
                                                    ref float capsArray,
                                                    ref int twMaxSize,
                                                    int errorMessage    );

		[DllImport("mgc4e.dll")]
		public static extern int meGetDefaultImageLayout (ref tw.TW_IMAGELAYOUT twImageLayout);
		[DllImport("mgc4e.dll")]
		public static extern int meGetImageLayout (ref tw.TW_IMAGELAYOUT twImageLayout);
		[DllImport("mgc4e.dll")]
		public static extern int meGetResolution (ushort twMsg, ref float xResolution, ref float yResolution);

		[DllImport("mgc4e.dll")]
		public static extern int meSetCapability (  ushort twMsg,
                                                    ushort twCap,
                                                    ushort twConType,
                                                    ushort twItemType,
                                                    ref int capsArray,
                                                    int twMaxSize,
                                                    int errorMessage    );
		[DllImport("mgc4e.dll")]
		public static extern int meSetCapability (  ushort twMsg,   
                                                    ushort twCap, 
                                                    ushort twConType,
                                                    ushort twItemType,
                                                    ref short capsArray,
                                                    int twMaxSize,
                                                    int errorMessage    );
		[DllImport("mgc4e.dll")]
		public static extern int meSetCapability (  ushort twMsg,
                                                    ushort twCap,
                                                    ushort twConType,
                                                    ushort twItemType,
                                                    ref float capsArray,
                                                    int twMaxSize,
                                                    int errorMessage    );

		[DllImport("mgc4e.dll")]
		public static extern int meSetImageLayout (ref tw.TW_IMAGELAYOUT twImageLayouhfdt);
		[DllImport("mgc4e.dll")]
		public static extern int meSetResolution (ushort twMsg, float xResolution, float yResolution);
		[DllImport("mgc4e.dll", CharSet = CharSet.Unicode)]
		public static extern int meShowDlgCaps (string title, IntPtr pWnd, int errorMessage);


		//
		//// ǎ摜
		//
		[DllImport("mgc4e.dll")]
		public static extern IntPtr meGetImage ();  
		[DllImport("mgc4e.dll")]
		public static extern int meGetImageInfo (ref tw.TW_IMAGEINFO imageInfo);
		[DllImport("mgc4e.dll")]
		public static extern int meDestroyImage ();
		[DllImport("mgc4e.dll")]
		public static extern IntPtr meSetImage(IntPtr pBitmap);  


		//
		//// ̑
		//

		// Pʕϊ
		[DllImport("mgc4e.dll")]
		public static extern float meFIX32ToFloat (ref tw.TW_FIX32 twFix32);
		[DllImport("mgc4e.dll")]
		public static extern tw.TW_FIX32 meFloatToFIX32(float floatingPoint);  
		[DllImport("mgc4e.dll")]
		public static extern float meInchToMM (float inch);
		[DllImport("mgc4e.dll")]
		public static extern int meInchToTwips (float inch);
		[DllImport("mgc4e.dll")]
		public static extern float meMMtoInch (float mm);
		[DllImport("mgc4e.dll")]
		public static extern int meMMToTwips (float mm);
		[DllImport("mgc4e.dll")]
		public static extern float meTwipsToInch (int twips);
		[DllImport("mgc4e.dll")]
		public static extern float meTwipsToMM (int twips);

		// 摜
		[DllImport("mgc4e.dll")]
		public static extern int meGetClipbordDIB (IntPtr pWnd);
		[DllImport("mgc4e.dll")]
		public static extern int meGetDIBSize (ref int height, ref int width);
		[DllImport("mgc4e.dll", CharSet = CharSet.Unicode)]
		public static extern int meLoadImage (string fileName, ref IntPtr reserved);
		[DllImport("mgc4e.dll", CharSet = CharSet.Unicode)]
		public static extern int meLoadImage (string fileName, IntPtr reserved);
		[DllImport("mgc4e.dll")]
		public static extern int mePaintDIB (IntPtr pDC, ref RECT DCRect, ref RECT DIBRect);
		[DllImport("mgc4e.dll", CharSet = CharSet.Unicode)]
		public static extern int meSaveImage (string fileName, int mode);
		[DllImport("mgc4e.dll")]
		public static extern int meSetClipbordDIB (IntPtr pWnd);

		// ̑
		[DllImport("mgc4e.dll")]
		public static extern int meCaptureButton (IntPtr pWnd) ;
		[DllImport("mgc4e.dll", CharSet = CharSet.Unicode)]
		public static extern int meGetFileVersion (     string file,
                                                    ref int major,
                                                    ref int minor,
                                                    ref int revision,
                                                    ref int build   );
		
	}
}
