#pragma once
#include "mb5e.h"

// CBEsergeant R}h ^[Qbg

class CBEsergeant : public CMb5e
{
public:
	CBEsergeant();
	virtual ~CBEsergeant();

public:
	INT beAdjustContrast(	HWND hWnd,
							INT nFunctions,
							CMBSE5E::LPADC_ADJUSTMENT lpAdjustment,
							CMBSE5E::LPIMAGEBAG lpImageBag,
							CMBSE5E::LPDISPLAY_PROCESS lpDisplay	);
	INT beAdjustGamma(	HWND hWnd, 
						INT nFunctions,
						CMBSE5E::LPADG_ADJUSTMENT lpAdjustment,
						CMBSE5E::LPIMAGEBAG lpImageBag,
						CMBSE5E::LPDISPLAY_PROCESS lpDisplay	);
	INT beAdjustGamma2(	HWND hWnd,
						INT nFunctions,
						CMBSE5E::LPADG_ADJUSTMENT2 lpAdjustment,
						CMBSE5E::LPIMAGEBAG lpImageBag,
						CMBSE5E::LPDISPLAY_PROCESS lpDisplay	);
	INT beAdjustQuality(	HWND hWnd,
							INT nFunctions,
							CMBSE5E::LPADQ_ADJUSTMENT lpAdjustment,
							CMBSE5E::LPIMAGEBAG lpImageBag,
							CMBSE5E::LPDISPLAY_PROCESS lpDisplay	);
	INT beCopy(	HWND hWnd, 
				INT nFunctions, 
				CMBSE5E::LPCPY_PARAMS lpParams, 
				CMBSE5E::LPIMAGEBAG lpImageBag,
				CMBSE5E::LPIMAGEBAG lpNewImageBag	);
	CMBSE5E::LPIMAGEBAG beCopy(	HWND hWnd, 
							INT nFunctions,
							CMBSE5E::LPCPY_PARAMS lpParams, 
							INT nReverseBuffer,
							CMBSE5E::LPIMAGEBAG lpImageBag, 
							CMBSE5E::LPDISPLAY_PROCESS lpDisplay,
							INT* lpReturn	);
	CMBSE5E::LPIMAGEBAG beDecolor(	HWND hWnd, 
								INT  nFunctions, 
								INT nNewBPP, 
								INT  nReverseBuffer,
								CMBSE5E::LPIMAGEBAG lpImageBag,
								CMBSE5E::LPDISPLAY_PROCESS lpDisplay,
								INT* lpReturn	);
	INT beRotete(	HWND hWnd, 
					CMBSE5E::LPIMAGEBAG lpImageBag,
					INT nDegrees,
					INT nFunctions,
					CMBSE5E::LPDISPLAY_PROCESS lpDisplay);
	INT beFilter(	HWND hWnd,
					INT nFunctions, 
					CMBSE5E::LPFLT_ADJUSTMENT lpAdjustment,
					CMBSE5E::LPIMAGEBAG lpImageBag, 
					CMBSE5E::LPDISPLAY_PROCESS lpDisplay	);

	INT beGetSizeForCopy(CMBSE5E::LPCPY_PARAMS lpParams, CMBSE5E::LPIMAGEBAG lpImageBag);


	CMBSE5E::LPIMAGEBAG beAttachImage(INT nFunctions, LPVOID lpBitmap);
	CMBSE5E::LPIMAGEBAG beCreateImage(INT nFunctions, INT nWidth, INT nHeight, INT nBPP);
	BOOL beDrawImage(	HDC hDestDC,
						INT nDestX,
						INT nDestY,
						INT nDestWidth, 
						INT nDestHeight, 
						INT nSrcX,
						INT nSrcY,
						DWORD dwROP,
						CMBSE5E::LPIMAGEBAG lpSrcImage	);
	VOID beDestroyImage(CMBSE5E::LPIMAGEBAG lpImageBag);
	DWORD beGetColor(CMBSE5E::LPIMAGEBAG lpImageBag, INT nX, INT nY);
	CMBSE5E::LPIMAGEBAG beLoadImage(BOOL bShowUI, INT nFunctions, LPTSTR lpszFileName);
	INT beSaveImage(	BOOL bShowUI,
						CMBSE5E::LPIMAGEBAG lpImageBag,
						LPTSTR lpszFileName,
						CMBSE5E::LPJPEG_PROCESS lpJpeg	);


	INT beCountColor(HWND hWnd, CMBSE5E::LPIMAGEBAG lpImageBag, CMBSE5E::LPDISPLAY_PROCESS lpDisplay);
	VOID beGetImageData(CMBSE5E::LPIMAGEBAG lpImageBag, INT *lpWidth, INT *lpHeight, INT *lpBPP);
	INT beGetHistogram(	HWND hWnd, 
						CMBSE5E::LPIMAGEBAG lpImageBag,
						INT nN,
						CMBSE5E::LPDISPLAY_PROCESS lpDisplay,
						CMBSE5E::LPHST_HISTOGRAM lphstData	); 
	

	INT beReverseAction(INT nFunctions, CMBSE5E::LPIMAGEBAG lpBuffer);
	

	INT beGetClipboardImage(HWND hWnd, CMBSE5E::LPIMAGEBAG lpImageBag, INT nReverseBuffer);
	CMBSE5E::LPIMAGEBAG beGetClipboardImage(HWND hWnd, INT nReverseBuffer);
	INT beSetClipboardImage(	HWND hWnd, 
								CMBSE5E::LPCPY_PARAMS lpParams,
								CMBSE5E::LPIMAGEBAG lpImageBag, 
								BOOL bZone	);
	
	
	INT beGetFileVersion(	LPCTSTR lpszFile,
							DWORD* lpMajor,
							DWORD* lpMinor,
							DWORD* lpRevision,
							DWORD* lpBuild	);

private:
	INT MergeImage(HWND hWnd, INT nType, CMBSE5E::LPIMAGEBAG lpSource, CMBSE5E::LPIMAGEBAG lpDestination);
	INT ShowFileDialog(LPTSTR lpszFileName, LPINT lpFunctions);
	INT ShowFileDialog(LPTSTR lpszFileName);
};