// ChildFrm.cpp : CChildFrame NX̎
//
#include "stdafx.h"
#include "TestEx.h"
#include "ChildFrm.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CChildFrame

IMPLEMENT_DYNCREATE(CChildFrame, CMDIChildWnd)

BEGIN_MESSAGE_MAP(CChildFrame, CMDIChildWnd)
	ON_COMMAND(ID_FILE_CLOSE, OnFileClose)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_HSCROLL()
	ON_WM_SIZE()
	ON_WM_TIMER()
	ON_WM_VSCROLL()
END_MESSAGE_MAP()


// CChildFrame RXgNV/fXgNV

CChildFrame::CChildFrame()
{
	// TODO: oR[hɒǉĂB
	m_nVs = m_nHs = 0;
	m_Vo.x = m_Vo.y = 0;
}

CChildFrame::~CChildFrame()
{
}

BOOL CChildFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: CREATESTRUCT cs ύXāAWindow NX܂̓X^CύX܂B
	if(!CMDIChildWnd::PreCreateWindow(cs) )
		return FALSE;
	
	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.style &= ~FWS_ADDTOTITLE;
	//cs.style |= WS_HSCROLL;
//	wsprintf(m_lpszTitle, "%04d", theApp.m_nChildCount);
//	cs.lpszName = m_lpszTitle;
	cs.lpszClass = AfxRegisterWndClass(0);
	
	return TRUE;
}


// CChildFrame ff

#ifdef _DEBUG
void CChildFrame::AssertValid() const
{
	CMDIChildWnd::AssertValid();
}

void CChildFrame::Dump(CDumpContext& dc) const
{
	CMDIChildWnd::Dump(dc);
}

#endif //_DEBUG


// CChildFrame bZ[W nh
void CChildFrame::OnFileClose() 
{
	// ̃t[ɂ́AWM_CLOSE 𑗂܂B̃bZ[ẂA
	// VXe j[ [] IꍇƓłB
	SendMessage(WM_CLOSE);
}

int CChildFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if(CMDIChildWnd::OnCreate(lpCreateStruct)  ==  -1)
		return -1;
	
	// t[̃NCAg̈Ŝ߂r[쐬܂B
	if(!m_wndView.Create(	NULL, 
							NULL, 
							AFX_WS_DEFAULT_VIEW, 
							CRect(0, 0, 0, 0), 
							this, 
							AFX_IDW_PANE_FIRST, 
							NULL	)				)
	{
		TRACE0("r[ EBhE쐬ł܂łB\n");
		return -1;
	}
	
	// XN[o[
	m_wndView.SetHs(0);
	m_wndView.SetVs(0);

	SetIcon(theApp.LoadIcon(IDI_IMAGE_FILE), TRUE);

	return 0;
}

void CChildFrame::OnDestroy()
{
	CMDIChildWnd::OnDestroy();

	CChildView::LPIMAGE_INFO lpImageInfo = m_wndView.GetImageInfo();
	theApp.FileList(CTestExApp::DEL_FILENAME, lpImageInfo->szFileName);
	theApp.HideToolBar();
}


BOOL CChildFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) 
{
	// r[ɍŏɃR}h@^܂B
	if (m_wndView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;
		
	// ȊȌꍇ́Ȁs܂B
	return CMDIChildWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

void CChildFrame::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	switch(nSBCode) 
	{
	case SB_TOP:		// ԏ܂ŃXN[B
		m_nVs = 0;
		break;
    case SB_BOTTOM:		// ԉ܂ŃXN[B 
		m_nVs = 100;
		break;
	case SB_PAGEUP:		// 1 y[WփXN[B
		m_nVs -= 10;	// 킴 break ĂȂ
	case SB_LINEUP:		// 1 sփXN[B 
		m_nVs = max(0, m_nVs - 10);
		break;
	case SB_PAGEDOWN:	// 1 y[WփXN[B 
		m_nVs += 10;
	case SB_LINEDOWN:	// 1 sփXN[B
		m_nVs = min(100, m_nVs + 10);
		break;
	case SB_THUMBPOSITION:	// ΈʒuփXN[B݈ʒu̓p[^ nPos Ŏw肳܂B 
	case SB_THUMBTRACK:		// XN[ {bNXwʒuփhbOB݈ʒu̓p[^ nPos Ŏw肳܂B 
		m_nVs = (int)nPos;
		break;
	}

	m_wndView.SetVs(m_nVs);

    // ŕ`悷
	SetScrollPos(SB_VERT, m_nVs);

	InvalidateRect(NULL);
	
	CMDIChildWnd::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CChildFrame::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// pScrollBar  NULL ȂEBhE_CAOɕtĂ
    // XN[o[Ȃ̂łł͉Ȃ
    //if(pScrollBar == NULL) 
	//{
	//	CMDIChildWnd::OnHScroll(nSBCode, nPos, pScrollBar);
	//	return;
	//}
	// XN[o[ꂽɂČ݂̈ʒuvZ
	// XN[o[̒l͈̔͂̓ftHg 0 ` 100 łB
	switch(nSBCode) 
	{  
    case SB_LEFT:	// [ɂ
		m_nHs = 0;
		break;
	case SB_RIGHT:	// E[ɂ
		m_nHs = 100;
        break;
	case SB_PAGELEFT:	// ܂݂̗̍]ꂽ
		m_nHs -= 10;	// 킴 break ĂȂ
	case SB_LINELEFT:	// {^ꂽ
		m_nHs = max(0, m_nHs - 10);
        break;
	case SB_PAGERIGHT:
		m_nHs += 10;
	case SB_LINERIGHT:
		m_nHs = min(100, m_nHs + 10);
		break;
	case SB_THUMBPOSITION:
	case SB_THUMBTRACK:
		m_nHs = (int)nPos;
		break;
	}

	m_wndView.SetHs(m_nHs);

    // ŕ`悷
	SetScrollPos(SB_HORZ, m_nHs);
	InvalidateRect(NULL);
	
	CMDIChildWnd::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CChildFrame::OnSize(UINT nType, int cx, int cy)
{
	CMDIChildWnd::OnSize(nType, cx, cy);

	if(nType == SIZE_RESTORED || nType == SIZE_MAXIMIZED)
	{
		GetClientRect(&m_Client);
		SetScrollBar();
	}
}

void CChildFrame::OnTimer(UINT_PTR nIDEvent)
{
	if(nIDEvent == 1) 
	{
		RECT rect;
		m_wndView.SetMessageUndo(_T("\0"));
		m_wndView.GetAreaToErase(&rect);
		InvalidateRect(&rect, FALSE);
		KillTimer(1);
	}

	CMDIChildWnd::OnTimer(nIDEvent);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
//// pubN֐
/////////////////////////////////////////////////////////////////////////////////////////////////////
void CChildFrame::SetScrollBar()
{
	CChildView::LPIMAGE_INFO lpImageInfo = m_wndView.GetImageInfo();

	INT nViewWidth  = lpImageInfo->nMagWidth;
	INT nViewHeight = lpImageInfo->nMagHeight;

	m_Vo.x = 0;
	m_Vo.y = 0;
    m_nHs = 0;
	m_nVs = 0;

	m_wndView.SetVo(&m_Vo);
	m_wndView.SetHs(m_nHs);
	m_wndView.SetVs(m_nVs);

	

	// XN[o[쐬
	if(nViewWidth > m_Client.right)
	{
		ShowScrollBar(SB_HORZ, TRUE);
		SetScrollRange(SB_HORZ, 0, 100, TRUE);
		SetScrollPos(SB_HORZ, 0, TRUE);
	}
	else 
	{
		ShowScrollBar(SB_HORZ, FALSE);
	}

	if(nViewHeight > m_Client.bottom)
	{
		ShowScrollBar(SB_VERT, TRUE);
		SetScrollRange(SB_VERT, 0, 100, TRUE);
		SetScrollPos(SB_VERT, 0, TRUE);
	}
	else 
	{
		ShowScrollBar(SB_VERT, FALSE);
	}
}

void CChildFrame::SetViewInfo(CChildView::LPIMAGE_INFO lpViewInfo)
{
	CChildView::LPIMAGE_INFO lpInfo = m_wndView.GetImageInfo();
	CopyMemory(lpInfo, lpViewInfo, sizeof(CChildView::IMAGE_INFO));
	SetMagnification(lpViewInfo->nRealMagnifications, lpViewInfo->nMagnifications);
	SetWText();
}

void CChildFrame::SetMagnification(DOUBLE nRealMagnifications, INT nMagnifications)
{
	m_wndView.SetMagnification(nRealMagnifications, nMagnifications);
}

CMBSE5E::LPIMAGEBAG CChildFrame::GetImage()
{
	CChildView::LPIMAGE_INFO lpImageInfo = m_wndView.GetImageInfo();
	return lpImageInfo->lpImageBag;
}

void CChildFrame::SetImage(CMBSE5E::LPIMAGEBAG lpImageBag)
{
	CChildView::LPIMAGE_INFO lpImageInfo = m_wndView.GetImageInfo();
	lpImageInfo->lpImageBag = lpImageBag;
}

LPTSTR CChildFrame::GetFileName()
{
	CChildView::LPIMAGE_INFO lpImageInfo = m_wndView.GetImageInfo();
	return lpImageInfo->szFileName;
}

CMBSE5E::LPHST_HISTOGRAM CChildFrame::GetHistData()
{
	CChildView::LPIMAGE_INFO lpImageInfo = m_wndView.GetImageInfo();
	return  lpImageInfo->lpHistData;
}

CMGC4IZ::LPFIELD_STRINGS CChildFrame::GetFieldText()
{
	CChildView::LPIMAGE_INFO lpImageInfo = m_wndView.GetImageInfo();
	return lpImageInfo->lpField;
}

void CChildFrame::SetFileName(LPCTSTR lpszFileName)
{
	CChildView::LPIMAGE_INFO lpImageInfo = m_wndView.GetImageInfo();
	lstrcpy(lpImageInfo->szFileName, lpszFileName);
	SetWText();
}

void CChildFrame::SetEdited(BOOL bEdited)
{
	CChildView::LPIMAGE_INFO lpImageInfo = m_wndView.GetImageInfo();
	lpImageInfo->bEdited = bEdited;
	SetWText();
}

void CChildFrame::SetWText()
{
			INT		nN1, nN2;
			INT		nLen;
			TCHAR	szTitle[MAX_PATH];
			TCHAR	szTmp[MAX_PATH];
			LPTSTR	lpszFormat;
	static	INT		nCount = 0;
			

	CChildView::LPIMAGE_INFO lpImageInfo = m_wndView.GetImageInfo();
	lstrcpy(szTmp, lpImageInfo->szFileName);
	nLen = lstrlen(szTmp);
	nN1 = 16;
	nN2 = nLen - 20;

	if(nLen > 40) 
	{
		// SpEpH
		if(		(BYTE)szTmp[nN1 - 1] >= 0x81 && (BYTE)szTmp[nN1 - 1] <= 0x9f
			||	(BYTE)szTmp[nN1 - 1] >= 0xe0 && (BYTE)szTmp[nN1 - 1] <= 0xef 	  )
		{
			nN1++;
		}

		if(		(BYTE)szTmp[nN2 - 1] >= 0x81 && (BYTE)szTmp[nN2 - 1] <= 0x9f 
			||	(BYTE)szTmp[nN2 - 1] >= 0xe0 && (BYTE)szTmp[nN2 - 1] <= 0xef  )
		{
			nN2--;
		}

		szTmp[nN1] = 0;

		if(lpImageInfo->bEdited)
			lpszFormat = _T("* %s....%s");
		else
			lpszFormat = _T("%s....%s");

		wsprintf(szTitle, lpszFormat, &szTmp[0], &szTmp[nN2]);
	}
	else if(nLen == 0) 
	{
		nCount++;
		TCHAR szBuffer[64];
		LoadString(theApp.m_hInstance, IDS_TEX_FILE_UNKOWN, szBuffer, 64);
		wsprintf(szTitle, _T("%s - %03d"), szBuffer, nCount);
	}
	else
	{
		if(lpImageInfo->bEdited)
			lpszFormat =  _T("* %s");
		else
			lpszFormat = _T("%s");

		wsprintf(szTitle, lpszFormat, szTmp);
	}

	SetWindowText(szTitle);
}

void CChildFrame::SetMsgUndo(LPTSTR lpszMsg)
{
	if(lpszMsg != NULL) 
	{
		m_wndView.SetMessageUndo(lpszMsg);
		SetTimer(1, 5000, 0);
	}
}

void CChildFrame::SetHScrollPos(UINT nSBCode)
{
	switch(nSBCode) 
	{
	case SB_LINELEFT: // {^ꂽ
		m_nHs = max(0, m_nHs - 20);
		break;
	case SB_LINERIGHT:
		m_nHs = min(100, m_nHs + 20);
	}

	SetScrollPos(SB_HORZ, m_nHs);
	m_wndView.SetHs(m_nHs);
	
	InvalidateRect(NULL);
}

BOOL CChildFrame::GetEdited()
{
	CChildView::LPIMAGE_INFO lpImageInfo = m_wndView.GetImageInfo();
	return lpImageInfo->bEdited;
}