// DlgProgress.cpp : t@C
//
#include "stdafx.h"
#include "TestEx.h"
#include "DlgProgress.h"


// CDlgProgress _CAO

IMPLEMENT_DYNAMIC(CDlgProgress, CDialog)
CDlgProgress::CDlgProgress(INT nMode, CWnd* pParent /*=NULL*/)
	: CDialog(CDlgProgress::IDD, pParent)
{
	m_nMode = nMode;
}

CDlgProgress::~CDlgProgress()
{
}

void CDlgProgress::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PROGRESS_PROGRESS1, m_prg);
}


BEGIN_MESSAGE_MAP(CDlgProgress, CDialog)
END_MESSAGE_MAP()


// CDlgProgress bZ[W nh
void CDlgProgress::SetItem(UINT nTotalSize, UINT nSize)
{
	if(nSize == 0)
		m_prg.SetRange(0, 100);
		
	m_prg.SetPos(100 * nSize / nTotalSize);
	m_prg.InvalidateRect(NULL);
}

BOOL CDlgProgress::CaptureButton()
{
	return m_E.eCaptureButton(GetDlgItem(IDCANCEL)->m_hWnd);
}

BOOL CDlgProgress::OnInitDialog()
{
	CDialog::OnInitDialog();

	if(!m_nMode == CDlgProgress::CANCEL) 
	{
		RECT	rect;
		GetClientRect(&rect);
		GetDlgItem(IDC_PROGRESS_PROGRESS1)->SetWindowPos(	&CWnd::wndTop, 
															rect.left, 
															rect.top,
															rect.right,
															rect.bottom, 
															SWP_SHOWWINDOW	);

		GetDlgItem(IDCANCEL)->SetWindowPos(NULL, 0,0,0,0, SWP_HIDEWINDOW);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}
