#pragma once
#include "ChildView.h"
#include "afxwin.h"

// CDlgTone _CAO

class CDlgTone : public CDialog
{
	DECLARE_DYNAMIC(CDlgTone)

public:
	CDlgTone(BYTE* lpMappingData, INT* lpBase, INT nHist[6][256], CWnd* pParent = NULL);   // WRXgN^
	virtual ~CDlgTone();

// _CAO f[^
	enum { IDD = IDD_TONE };

protected:
	afx_msg void OnBnClickedButton1();
	afx_msg void OnBnClickedButton2();
	afx_msg void OnBnClickedButtonChannel();
	afx_msg void OnBnClickedButtonEnd();
	afx_msg void OnBnClickedButtonTone();
	afx_msg void OnBnClickedCancel();
	afx_msg void OnBnClickedOk();
	afx_msg void OnPaint();
	virtual BOOL OnInitDialog();
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	DECLARE_MESSAGE_MAP()
	
private:
	static const int MAP_BRIGHT0	= 0;
	static const int MAP_BRIGHT1	= 1;
	static const int MAP_BRIGHT2	= 2;
	static const int MAP_DARK0		= 3;
	static const int MAP_DARK1		= 4;
	static const int MAP_DARK2		= 5;
	static const int MAP_MIDDLE		= 6;
	static const int MAP_REVERSE	= 7;
	static const int MAP_COUNT		= 8;

	BYTE	m_szMappingData[MAP_COUNT][256];
	BYTE*	m_lpszM;
	INT		m_nColor;
	INT		m_nHist[6][256];
	INT		m_nMap;
	INT*	m_lpBase;
	TCHAR	m_szMappingText[MAP_COUNT][64];

	CBitmap m_bmpEnd;
	CButton m_btnChannel;
	CButton m_btnEnd;
	CButton m_btnTone;
	CButton m_chkConstantI;
	CImage	m_image1;
	CStatic m_labTitle;
};
