#include "stdafx.h"
#include "m3az.h"
// CM3az
//
//   mmgic3az.dll [hNXł
//
CM3az::CM3az()
{
	LPCTSTR lpDll = _T("mmgic3az.dll\0");

	m_hMAZ = LoadLibrary(lpDll);

	if(m_hMAZ != NULL) 
	{
		// fBXN
		CheckActiveDrive = (LPMAZCHECKACTIVEDRIVE)GetProcAddress(m_hMAZ, "mazCheckActiveDrive");
		GetDiskSize = (LPMAZGETDISKSIZE)GetProcAddress(m_hMAZ, "mazGetDiskSize");			
		GetDriveType = (LPMAZGETDRIVETYPE)GetProcAddress(m_hMAZ, "mazGetDriveType");
		GetLogicalDrives = (LPMAZGETLOGICALDRIVES)GetProcAddress(m_hMAZ, "mazGetLogicalDrives");
		GetVolumeInformation = (LPMAZGETVOLUMEINFORMATION)GetProcAddress(m_hMAZ, "mazGetVolumeInformation");

		// t@C
		GetFileAttributes = (LPMAZGETFILEATTRIBUTES)GetProcAddress(m_hMAZ, "mazGetFileAttributes");
		GetFileSize = (LPMAZGETFILESIZE)GetProcAddress(m_hMAZ, "mazGetFileSize");	
		GetFileTime = (LPMAZGETFILETIME)GetProcAddress(m_hMAZ, "mazGetFileTime"); 
		GetFileVersion = (LPMAZGETFILEVERSION)GetProcAddress(m_hMAZ, "mazGetFileVersion");
		GetFileVersionEx = (LPMAZGETFILEVERSIONEX)GetProcAddress(m_hMAZ, "mazGetFileVersionEx");
		GetLongFileName = (LPMAZGETLONGFILENAME)GetProcAddress(m_hMAZ, "mazGetLongFileName");
		GetShortFileName = (LPMAZGETSHORTFILENAME)GetProcAddress(m_hMAZ, "mazGetShortFileName");
		GetSpecialFolderPath = (LPMAZGETSPECIALFOLDERPATH)GetProcAddress(m_hMAZ, "mazGetSpecialFolderPath");
		GetTempFileName = (LPMAZGETTEMPFILENAME)GetProcAddress(m_hMAZ, "mazGetTempFileName");
		GetWindowsPath = (LPMAZGETWINDOWSPATH)GetProcAddress(m_hMAZ, "mazGetWindowsPath");
		SearchDirectory = (LPMAZSEARCHDIRECTORY)GetProcAddress(m_hMAZ, "mazSearchDirectory");
		SetFileAttributes = (LPMAZSETFILEATTRRBUTES)GetProcAddress(m_hMAZ, "mazSetFileAttributes");
		SetFileTime = (LPMAZSETFILETIME)GetProcAddress(m_hMAZ, "mazSetFileTime"); 
		ShowDirListBox = (LPMAZSHOWDIRLISTBOX)GetProcAddress(m_hMAZ, "mazShowDirListBox");
			 
		// WXg
		GetRegData = (LPMAZGETREGDATA)GetProcAddress(m_hMAZ, "mazGetRegData");
		SetRegData = (LPMAZSETREGDATA)GetProcAddress(m_hMAZ, "mazSetRegData");
	
		// VXe
		GetComputerName = (LPMAZGETCOMPUTERNAME)GetProcAddress(m_hMAZ, "mazGetComputerName");
		GetCpuInformationsA = (LPMAZGETCPUINFORMATIONSA)GetProcAddress(m_hMAZ, "mazGetCpuInformationsA");
		GetCpuInformationsB = (LPMAZGETCPUINFORMATIONSB)GetProcAddress(m_hMAZ, "mazGetCpuInformationsB");
		GetLoginName = (LPMAZGETLOGINNAME)GetProcAddress(m_hMAZ, "mazGetLoginName");
		GetMemoryStatusEx = (LPMAZGETMEMORYSTATUSEX)GetProcAddress(m_hMAZ, "mazGetMemoryStatusEx");
		GetWinVersion = (LPMAZGETWINVERSION)GetProcAddress(m_hMAZ, "mazGetWinVersion");
		
		// k/L
		Compress = (LPMAZCOMPRESS)GetProcAddress(m_hMAZ, "mazCompress");
		DecodeByHuffman = (LPMAZDECODEBYHUFFMAN)GetProcAddress(m_hMAZ, "mazDecodeByHuffman");
		DecodeByWeyl = (LPMAZDECODEBYWEYL)GetProcAddress(m_hMAZ, "mazDecodeByWeyl");
		DeleteCmpPack = (LPMAZDELETECMPPACK)GetProcAddress(m_hMAZ, "mazDeleteCmpPack");
		DeleteCmpPackHuffman = (LPMAZDELETECMPPACKHUFFMAN)GetProcAddress(m_hMAZ, "mazDeleteCmpPackHuffman");
		EncodeByHuffman = (LPMAZENCODEBYHUFFMAN)GetProcAddress(m_hMAZ, "mazEncodeByHuffman");
		EncodeByWeyl = (LPMAZENCODEBYWEYL)GetProcAddress(m_hMAZ, "mazEncodeByWeyl");
		Expand = (LPMAZEXPAND)GetProcAddress(m_hMAZ, "mazExpand");
		
		// Z֐
		AddInt64 = (LPMAZADDINT64)GetProcAddress(m_hMAZ, "mazAddInt64");
		CompareInt64 = (LPMAZCOMPAREINT64)GetProcAddress(m_hMAZ, "mazCompareInt64");
		DivideInt64 = (LPMAZDIVIDEINT64)GetProcAddress(m_hMAZ, "mazDivideInt64"); 	
		MultiplyInt64 = (LPMAZMULTIPLYINT64)GetProcAddress(m_hMAZ, "mazMultiplyInt64");
		SetInt64 = (LPMAZSETINT64)GetProcAddress(m_hMAZ, "mazSetInt64");
		SubtractInt64 = (LPMAZSUBTRACTINT64)GetProcAddress(m_hMAZ, "mazSubtractInt64");		

		// CRC
		GetCRC16 = (LPMAZAGETCRC16)GetProcAddress(m_hMAZ, "mazGetCRC16");
		GetCRC16ofFile = (LPMAZGETCRC16OFFILE)GetProcAddress(m_hMAZ, "mazGetCRC16ofFile");
		GetCRC32 = (LPMAZGETCRC32)GetProcAddress(m_hMAZ, "mazGetCRC32");
		GetCRC32ofFile = (LPMAZGETCRC32OFFILE)GetProcAddress(m_hMAZ, "mazGetCRC32ofFile");

		// /l ϊ
		CByteToInt16	= (LPMAZCBYTETOINT16)GetProcAddress(m_hMAZ, "mazCByteToInt16");
		CByteToInt32	= (LPMAZCBYTETOINT32)GetProcAddress(m_hMAZ, "mazCByteToInt32");
		CByteToInt64	= (LPMAZCBYTETOSTRING)GetProcAddress(m_hMAZ, "mazCByteToInt64");
		CByteToString 	= (LPMAZCBYTOTOINT64)GetProcAddress(m_hMAZ, "mazCByteToString");
		CDoubleToInt16	= (LPMAZCDOUBLETOINT16)GetProcAddress(m_hMAZ, "mazCDoubleToInt16");
		CDoubleToInt32	= (LPMAZCDOUBLETOINT32)GetProcAddress(m_hMAZ, "mazCDoubleToInt32");
		CDoubleToInt64	= (LPMAZCDOUBLETOINT64)GetProcAddress(m_hMAZ, "mazCDoubleToInt64");
		CDoubleToString	= (LPMAZCDOUBLETOSTRING)GetProcAddress(m_hMAZ, "mazCDoubleToString");
		CInt16ToByte	= (LPMAZCINT16TOBYTE)GetProcAddress(m_hMAZ, "mazCInt16ToByte");
		CInt16ToString	= (LPMAZCINT16TOSTRING)GetProcAddress(m_hMAZ, "mazCInt16ToString");
		CInt32ToByte	= (LPMAZCINT32TOBYTE)GetProcAddress(m_hMAZ, "mazCInt32ToByte");
		CInt32ToString	= (LPMAZCINT32TOSTRING)GetProcAddress(m_hMAZ, "mazCInt32ToString");
		CInt64ToByte	= (LPMAZCINT64TOBYTE)GetProcAddress(m_hMAZ, "mazCInt64ToByte");
		CInt64ToString	= (LPMAZCINT64TOSTRING)GetProcAddress(m_hMAZ, "mazCInt64ToString ");
		CSingleToInt16	= (LPMAZCSINGLETOINT16)GetProcAddress(m_hMAZ, "mazCSingleToInt16");
		CSingleToInt32	= (LPMAZCSINGLETOINT32)GetProcAddress(m_hMAZ, "mazCSingleToInt32");
		CSingleToInt64	= (LPMAZCSINGLETOINT64)GetProcAddress(m_hMAZ, "mazCSingleToInt64");
		CSingleToString	= (LPMAZCSINGLETOSTRING)GetProcAddress(m_hMAZ, "mazCSingleToString");
		CStringToByte	= (LPMAZCSTRINGTOBYTE)GetProcAddress(m_hMAZ, "mazCStringToByte");
		StringLower	= (LPMAZSTRINGLOWER)GetProcAddress(m_hMAZ, "mazStringLower");
		StringUpper	= (LPMAZSTRINGUPPER)GetProcAddress(m_hMAZ, "mazStringUpper");

		// lf[^
		Rand0d = (LPMAZRAND0D)GetProcAddress(m_hMAZ, "mazRand0d");
		Rand0i = (LPMAZRAND0I)GetProcAddress(m_hMAZ, "mazRand0i");
		SetSeed = (LPMAZSETSEED)GetProcAddress(m_hMAZ, "mazSetSeed");
		ShiftByteL = (LPMAZSHIFTBYTEL)GetProcAddress(m_hMAZ, "mazShiftByteL");
		ShiftByteR = (LPMAZSHIFTBYTER)GetProcAddress(m_hMAZ, "mazShiftByteR");
		ShiftInt16L = (LPMAZSHIFTINT16L)GetProcAddress(m_hMAZ, "mazShiftint16L");
		ShiftInt16R = (LPMAZSHIFTINT16R)GetProcAddress(m_hMAZ, "mazShiftint16R");
		ShiftInt32L = (LPMAZSHIFTINT32L)GetProcAddress(m_hMAZ, "mazShiftInt32L");
		ShiftInt32R = (LPMAZSHIFTINT32R)GetProcAddress(m_hMAZ, "mazShiftInt32R");
		ShiftInt64L = (LPMAZSHIFTINT64L)GetProcAddress(m_hMAZ, "mazShiftInt64L");
		ShiftInt64R = (LPMAZSHIFTINT64R)GetProcAddress(m_hMAZ, "mazShiftInt64R");

		// [
		BitArray = (LPMAZBITARRAY)GetProcAddress(m_hMAZ, "mazBitArray");
		CopyMemoryAZ = (LPMAZCOPYMEMORY)GetProcAddress(m_hMAZ, "mazCopyMemory");
		FillMemoryAZ = (LPMAZFILLMEMORY)GetProcAddress(m_hMAZ, "mazFillMemory");
		GlobalCopyAZ = (LPMAZGLOBALCOPY)GetProcAddress(m_hMAZ, "mazGlobalCopy");
		Queue = (LPMAZQUEUE)GetProcAddress(m_hMAZ, "mazQueue");
		Stack = (LPMAZSTACK)GetProcAddress(m_hMAZ, "mazStack");
		
		// ̑
		CaptureButton = (LPMAZCAPTUREBUTTON)GetProcAddress(m_hMAZ, "mazCaptureButton");
		GetClient = (LPMAZGETCLIENT)GetProcAddress(m_hMAZ, "mazGetClient");
		GetTime = (LPMAZGETTIME)GetProcAddress(m_hMAZ, "mazGetTime");
		GetWorkArea = (LPMAZGETWORKAREA)GetProcAddress(m_hMAZ, "mazGetWorkArea");


		//
		//// ffiKvȂύXj
		//
		if(GetFileVersionEx == NULL)
			Unload();
	}
}

CM3az::~CM3az()
{
	Unload();
}


// CM3az o֐
void CM3az::Unload()
{
	if(m_hMAZ) 
	{
		BOOL bR = FreeLibrary(m_hMAZ);
		m_hMAZ = NULL;
	}
}

int CM3az::AreYouReady()
{
	return (m_hMAZ != NULL)? MAZ_YES : MAZ_NO;
}