#pragma once
#include "mmgic3az.h"

// CM3az R}h ^[Qbg
//
//   mmgic3az.dll [hNXł
//
class CM3az : public CObject
{
public:
	CM3az();
	virtual ~CM3az();

	void Unload();
	int	 AreYouReady();

	//
	////  ֐`
	//

	// fBXN
	typedef BOOL  (CALLBACK* LPMAZGETDISKSIZE) ( LPCSTR	lpszDirectoryName, 
												 ULONGLONG*	lpFreeSize, 
												 ULONGLONG*	lpTotalSize	);			
	typedef UINT  (CALLBACK* LPMAZGETDRIVETYPE) (LPCSTR lpszDriveLetter);
	typedef DWORD (CALLBACK* LPMAZGETLOGICALDRIVES) (VOID);
	typedef INT   (CALLBACK* LPMAZGETVOLUMEINFORMATION) ( LPCSTR lpszRootPathName, 
														  LPMAZ_GVI_VOLUME_INFORMATION lpVolumeInformation);
	typedef BOOL  (CALLBACK* LPMAZCHECKACTIVEDRIVE) (LPCSTR lpszDriveLetter);

	// t@C
	typedef BOOL  (CALLBACK* LPMAZGETSPECIALFOLDERPATH) (LPSTR lpszPathName, INT nFolder);
	typedef BOOL  (CALLBACK* LPMAZSHOWDIRLISTBOX)   (LPMAZ_SDB_INFORMATION Info, LPSTR lpszDirectoryName);
	typedef DWORD (CALLBACK* LPMAZGETLONGFILENAME)  (LPCSTR lpszShortName, LPSTR lpszLongName);
	typedef DWORD (CALLBACK* LPMAZGETSHORTFILENAME) (LPCSTR lpszLongName, LPSTR lpszShortName);
	typedef INT   (CALLBACK* LPMAZGETTEMPFILENAME)  (LPSTR lpszFileName);
	typedef INT   (CALLBACK* LPMAZGETFILEATTRIBUTES) (LPCSTR lpszFileName, DWORD *lpdwAttributes);
	typedef INT   (CALLBACK* LPMAZGETFILETIME) ( const	DWORD	dwFunction, 
														LPCSTR lpszFileName, 
														LPSYSTEMTIME lpstCreateTime, 
														LPSYSTEMTIME lpstAccessTime, 
														LPSYSTEMTIME lpstWriteTime	);
	typedef INT   (CALLBACK* LPMAZGETFILEVERSION) (	LPCSTR lpszFile, 
													LPDWORD	lpdwMajor, 
													LPDWORD	lpdwMinor, 
													LPDWORD	lpdwRevision, 
													LPDWORD	lpdwBild	);

	typedef INT   (CALLBACK* LPMAZGETFILEVERSIONEX) ( LPCSTR lpszFileName,
												const ULONG	  nSize, 
													  LPMAZ_GFV_FILE_VERSION lpVersion );

	typedef INT   (CALLBACK* LPMAZGETWINDOWSPATH) (const DWORD dwFunction, LPSTR lpszPath);
	typedef INT   (CALLBACK* LPMAZSEARCHDIRECTORY) ( const	DWORD	dwFunction, 
															LPCSTR lpszDirectory, 
															LPCSTR lpszExtension, 
															LPCSTR lpszListFile, 
															LPMAZ_SDR_DIRECTORY_SEARCH lpDirSearch	); 
	typedef INT   (CALLBACK* LPMAZSETFILEATTRRBUTES) (LPCSTR lpszFileName, const DWORD dwAttributes);
	typedef INT   (CALLBACK* LPMAZSETFILETIME) ( const	DWORD		 dwFunction, 
														LPCSTR		 lpszFileName, 
														LPSYSTEMTIME lpstCreateTime, 
														LPSYSTEMTIME lpstAccessTime, 
														LPSYSTEMTIME lpstWriteTime	);
	typedef ULONGLONG (CALLBACK* LPMAZGETFILESIZE)(LPCSTR lpszFileName);

	// WXg
	typedef INT (CALLBACK* LPMAZGETREGDATA) ( const	DWORD	dwFunction, 
											  const	INT		nKey, 
											 		LPCSTR lpszSubKey, 
													LPCSTR lpszName, 
													DWORD	dwType, 
													LPBYTE	lpData, 
													LPDWORD lpdwSize );
	typedef INT (CALLBACK* LPMAZSETREGDATA) ( const	INT		nKey, 
													LPCSTR lpszSubKey, 
													LPCSTR lpszName, 
													DWORD	dwType, 
													LPBYTE	lpData, 
											const	DWORD   lpdwSize );

	// VXe
	typedef INT  (CALLBACK* LPMAZGETCOMPUTERNAME) (LPSTR lpszComputerName);
	typedef INT  (CALLBACK* LPMAZGETCPUINFORMATIONSA) (	PMAZ_GCI_INFORMATION_A lpInformationsA, 
														LPCSTR	lpszFileName	);
	typedef INT  (CALLBACK* LPMAZGETCPUINFORMATIONSB) ( const DWORD dwTime, 
															  PMAZ_GCI_INFORMATION_B lpInformationsB );
	typedef INT  (CALLBACK* LPMAZGETLOGINNAME) (LPSTR lpszLoginName);
	typedef INT  (CALLBACK* LPMAZGETMEMORYSTATUSEX) (LPMEMORYSTATUSEX lpBuffer);
	typedef VOID (CALLBACK* LPMAZGETWINVERSION) (LPOSVERSIONINFO lpVersionInfo);

	// k/L
	typedef INT   (CALLBACK* LPMAZENCODEBYHUFFMAN) (BYTE  szSource[], LPMAZ_CMP_PACK_HUFF lpCmpPack);
	typedef UINT  (CALLBACK* LPMAZDECODEBYWEYL) ( BYTE  szSource[], 
												  ULONG nOriginal[], 
												  UINT  nOriginalSize	);
	typedef UINT  (CALLBACK* LPMAZENCODEBYWEYL) ( ULONG nSource[], 
												  BYTE  szDestination[],
												  UINT  nSourceSize, 
												  UINT  nDestinationSize	);
	typedef	INT   (CALLBACK* LPMAZCOMPRESS) (BYTE szData[], LPMAZ_CMP_PACK_LZ lpCmpPack);
	typedef	INT   (CALLBACK* LPMAZDECODEBYHUFFMAN) ( LPMAZ_CMP_PACK_HUFF lpCmpPack, 
													 BYTE szDestination[] );	
	typedef	INT   (CALLBACK* LPMAZEXPAND) (LPMAZ_CMP_PACK_LZ lpCmpPack, BYTE szData[]);
	typedef	VOID  (CALLBACK* LPMAZDELETECMPPACK) (LPMAZ_CMP_PACK_LZ lpCmpPack);
	typedef	VOID  (CALLBACK* LPMAZDELETECMPPACKHUFFMAN) (LPMAZ_CMP_PACK_HUFF lpCmpPack);

	// Z֐
	typedef INT      (CALLBACK* LPMAZCOMPAREINT64) (LONGLONG* lpA, LONGLONG* lpB);
	typedef LONGLONG (CALLBACK* LPMAZADDINT64) (LONGLONG* lpA, LONGLONG* lpB);
	typedef LONGLONG (CALLBACK* LPMAZDIVIDEINT64) (LONGLONG* lpA, LONGLONG* lpB); 	
	typedef LONGLONG (CALLBACK* LPMAZMULTIPLYINT64) (LONGLONG* lpA, LONGLONG* lpB);	
	typedef LONGLONG (CALLBACK* LPMAZSETINT64) (LPSTR lpszNumber);
	typedef LONGLONG (CALLBACK* LPMAZSUBTRACTINT64) (LONGLONG* lpA, LONGLONG* lpB);

	// CRC
	typedef ULONG  (CALLBACK* LPMAZGETCRC32) (BOOL bReset, ULONG nN, BYTE szA[]);
	typedef ULONG  (CALLBACK* LPMAZGETCRC32OFFILE) (LPSTR lpFileName);
	typedef USHORT (CALLBACK* LPMAZGETCRC16OFFILE) (LPSTR lpFileName);
	typedef	USHORT (CALLBACK* LPMAZAGETCRC16) (BOOL bReset, USHORT nN, BYTE szA[]);

	// /l ϊ
	typedef USHORT  (CALLBACK* LPMAZCBYTETOINT16) (const BYTE szB[]);
	typedef ULONG   (CALLBACK* LPMAZCBYTETOINT32) (const BYTE szB[]);
	typedef ULONG   (CALLBACK* LPMAZCBYTETOSTRING) ( const BYTE szB[], 
														   LPSTR lpS, 
													 const ULONG nSize );
	typedef ULONGLONG (CALLBACK* LPMAZCBYTOTOINT64) (const BYTE szB[]);
	typedef SHORT	(CALLBACK* LPMAZCDOUBLETOINT16) (const DOUBLE nD);
	typedef INT 	(CALLBACK* LPMAZCDOUBLETOINT32) (const DOUBLE nD);
	typedef LONGLONG (CALLBACK* LPMAZCDOUBLETOINT64) (const DOUBLE nD);
	typedef VOID 	(CALLBACK* LPMAZCDOUBLETOSTRING) ( const DOUBLE	nD, 
													   const INT	nType, 
															 LPSTR	lpszS	);
	typedef VOID    (CALLBACK* LPMAZCINT16TOBYTE) (const SHORT nS, BYTE szB[]);
	typedef VOID    (CALLBACK* LPMAZCINT16TOSTRING) ( const	SHORT	nS,
													  const	INT		nRadix, 
																LPSTR	lpszS	);
	typedef VOID    (CALLBACK* LPMAZCINT32TOBYTE) (const LONG nL, BYTE szB[]);
	typedef VOID    (CALLBACK* LPMAZCINT32TOSTRING) ( const LONG	nL, 
													  const INT	nRadix, 
															LPSTR lpszS	);
	typedef VOID    (CALLBACK* LPMAZCINT64TOBYTE) (const ULONGLONG* lp64, BYTE szB[]);
	typedef VOID    (CALLBACK* LPMAZCINT64TOSTRING) ( const	ULONGLONG*	lpB, 
													  const	INT			nRadix, 
															LPSTR		lpszS	);
	typedef SHORT 	(CALLBACK* LPMAZCSINGLETOINT16) (const FLOAT nF);
	typedef INT 	(CALLBACK* LPMAZCSINGLETOINT32) (const FLOAT nF);
	typedef LONGLONG (CALLBACK* LPMAZCSINGLETOINT64) (const FLOAT nF);
	typedef VOID 	(CALLBACK* LPMAZCSINGLETOSTRING) ( const	FLOAT	nF,
													   const	INT		nType, 
																LPSTR	lpszS	);
	typedef ULONG   (CALLBACK* LPMAZCSTRINGTOBYTE) ( LPCSTR lpS, 
													 BYTE szB[], 
											   const ULONG nSize );
	typedef VOID    (CALLBACK* LPMAZSTRINGLOWER) (LPSTR lpszS);
	typedef VOID    (CALLBACK* LPMAZSTRINGUPPER) (LPSTR lpszS);

	// lf[^
	typedef BYTE      (CALLBACK* LPMAZSHIFTBYTEL) (const BYTE szA, const INT nShift);
	typedef BYTE      (CALLBACK* LPMAZSHIFTBYTER) (const BYTE szA, const INT nShift);
	typedef DOUBLE	  (CALLBACK* LPMAZRAND0D) (VOID);
	typedef ULONG     (CALLBACK* LPMAZSHIFTINT32L) (const ULONG nA, const INT nShift);
	typedef ULONG     (CALLBACK* LPMAZSHIFTINT32R) (const ULONG nA, const INT nShift);
	typedef ULONG	  (CALLBACK* LPMAZRAND0I) (VOID);	
	typedef ULONGLONG (CALLBACK* LPMAZSHIFTINT64L) (const ULONGLONG* lpA, const INT nShift);
	typedef ULONGLONG (CALLBACK* LPMAZSHIFTINT64R) (const ULONGLONG* lpA, const INT nShift);
	typedef USHORT    (CALLBACK* LPMAZSHIFTINT16L) (const USHORT nA, const INT nShift);
	typedef USHORT    (CALLBACK* LPMAZSHIFTINT16R) (const USHORT nA, const INT nShift);
	typedef VOID	  (CALLBACK* LPMAZSETSEED) (ULONG nX);	

	// [
	typedef DWORD     (CALLBACK* LPMAZBITARRAY) ( INT  nCommand, 
											const INT  nX, 
											const INT  nY, 
												  INT* lpPage);
	typedef INT       (CALLBACK* LPMAZQUEUE) (const INT nFunction, LPVOID lpQueue, LPVOID lpValue);
	typedef INT       (CALLBACK* LPMAZSTACK) (const INT nFunction, LPVOID lpStack, LPVOID lpValue);
	typedef VOID      (CALLBACK* LPMAZFILLMEMORY) (LPVOID lpDestination, BYTE szFill, INT nSize); 
	typedef VOID      (CALLBACK* LPMAZGLOBALCOPY) (	const	LPVOID	lpDestination, 
													const	HGLOBAL hSource, 
													const	DWORD	dwSize ); 
	typedef VOID	  (CALLBACK* LPMAZCOPYMEMORY) (	LPVOID	lpDestination, 
											const	LPVOID	lpSource, 
													INT		nSize	);
	typedef VOID	  (CALLBACK* LPMAZCOPYMEMORY) (	LPVOID	lpDestination, 
											const	LPVOID	lpSource, 
													INT		nSize	);

	// ̑
	typedef BOOL (CALLBACK* LPMAZCAPTUREBUTTON) (HWND hWnd);
	typedef BOOL (CALLBACK* LPMAZGETWORKAREA) (LPRECT lpWorkArea, INT nReserved);
	typedef VOID (CALLBACK* LPMAZGETCLIENT) (HWND hWnd, LPRECT lpClient);
	typedef VOID (CALLBACK* LPMAZGETTIME) (LPSYSTEMTIME lpTime, INT nTime);


	// fBXN
	LPMAZCHECKACTIVEDRIVE		CheckActiveDrive;
	LPMAZGETDISKSIZE			GetDiskSize;		
	LPMAZGETDRIVETYPE			GetDriveType;
	LPMAZGETLOGICALDRIVES		GetLogicalDrives;
	LPMAZGETVOLUMEINFORMATION	GetVolumeInformation;
	
	// t@C
	LPMAZGETFILEATTRIBUTES		GetFileAttributes;
	LPMAZGETFILESIZE			GetFileSize;
	LPMAZGETFILETIME			GetFileTime;
	LPMAZGETFILEVERSION			GetFileVersion;
	LPMAZGETFILEVERSIONEX		GetFileVersionEx;
	LPMAZGETLONGFILENAME		GetLongFileName;
	LPMAZGETSHORTFILENAME		GetShortFileName;
	LPMAZGETSPECIALFOLDERPATH	GetSpecialFolderPath;
	LPMAZGETTEMPFILENAME		GetTempFileName;
	LPMAZGETWINDOWSPATH			GetWindowsPath;
	LPMAZSEARCHDIRECTORY		SearchDirectory;
	LPMAZSETFILEATTRRBUTES		SetFileAttributes;
	LPMAZSETFILETIME			SetFileTime; 
	LPMAZSHOWDIRLISTBOX			ShowDirListBox;
	
	// WXg
	LPMAZGETREGDATA		GetRegData;
	LPMAZSETREGDATA		SetRegData;
	
	// VXe
	LPMAZGETCOMPUTERNAME		GetComputerName;
	LPMAZGETCPUINFORMATIONSA	GetCpuInformationsA;
	LPMAZGETCPUINFORMATIONSB	GetCpuInformationsB;
	LPMAZGETLOGINNAME			GetLoginName;
	LPMAZGETMEMORYSTATUSEX		GetMemoryStatusEx;
	LPMAZGETWINVERSION			GetWinVersion;
	
	// k/L
	LPMAZCOMPRESS				Compress;
	LPMAZDECODEBYHUFFMAN		DecodeByHuffman;
	LPMAZDECODEBYWEYL			DecodeByWeyl;
	LPMAZDELETECMPPACK			DeleteCmpPack;
	LPMAZDELETECMPPACKHUFFMAN	DeleteCmpPackHuffman;
	LPMAZENCODEBYHUFFMAN		EncodeByHuffman;
	LPMAZENCODEBYWEYL			EncodeByWeyl;
	LPMAZEXPAND					Expand;
	
	// Z֐
	LPMAZADDINT64		AddInt64;
	LPMAZCOMPAREINT64	CompareInt64;
	LPMAZDIVIDEINT64	DivideInt64; 	
	LPMAZMULTIPLYINT64	MultiplyInt64;
	LPMAZSETINT64		SetInt64;
	LPMAZSUBTRACTINT64	SubtractInt64;
	
	//CRC
	LPMAZAGETCRC16		GetCRC16;
	LPMAZGETCRC16OFFILE	GetCRC16ofFile;
	LPMAZGETCRC32		GetCRC32;
	LPMAZGETCRC32OFFILE	GetCRC32ofFile;
	
	// /l ϊ
	LPMAZCBYTETOINT16		CByteToInt16;
	LPMAZCBYTETOINT32		CByteToInt32;
	LPMAZCBYTETOSTRING		CByteToInt64;
	LPMAZCBYTOTOINT64		CByteToString; 
	LPMAZCDOUBLETOINT16		CDoubleToInt16;
	LPMAZCDOUBLETOINT32		CDoubleToInt32;
	LPMAZCDOUBLETOINT64		CDoubleToInt64;
	LPMAZCDOUBLETOSTRING	CDoubleToString;
	LPMAZCINT16TOBYTE		CInt16ToByte;
	LPMAZCINT16TOSTRING		CInt16ToString;
	LPMAZCINT32TOBYTE		CInt32ToByte;
	LPMAZCINT32TOSTRING		CInt32ToString; 
	LPMAZCINT64TOBYTE		CInt64ToByte;
	LPMAZCINT64TOSTRING		CInt64ToString;
	LPMAZCSINGLETOINT16		CSingleToInt16;
	LPMAZCSINGLETOINT32		CSingleToInt32;
	LPMAZCSINGLETOINT64		CSingleToInt64;
	LPMAZCSINGLETOSTRING	CSingleToString;
	LPMAZCSTRINGTOBYTE		CStringToByte;
	LPMAZSTRINGLOWER		StringLower;
	LPMAZSTRINGUPPER		StringUpper;

	// lf[^
	LPMAZRAND0D			Rand0d;
	LPMAZRAND0I			Rand0i;
	LPMAZSETSEED		SetSeed;
	LPMAZSHIFTBYTEL		ShiftByteL;
	LPMAZSHIFTBYTER		ShiftByteR;
	LPMAZSHIFTINT16L	ShiftInt16L;
	LPMAZSHIFTINT16R	ShiftInt16R;
	LPMAZSHIFTINT32L	ShiftInt32L;
	LPMAZSHIFTINT32R	ShiftInt32R;
	LPMAZSHIFTINT64L	ShiftInt64L;
	LPMAZSHIFTINT64R	ShiftInt64R;
	
	// [
	LPMAZBITARRAY		BitArray; 
	LPMAZQUEUE			Queue;
	LPMAZSTACK			Stack;
	LPMAZFILLMEMORY		FillMemoryAZ;
	LPMAZGLOBALCOPY		GlobalCopyAZ;
	LPMAZCOPYMEMORY		CopyMemoryAZ;
	
	// ̑
	LPMAZCAPTUREBUTTON	CaptureButton;
	LPMAZGETCLIENT		GetClient;
	LPMAZGETTIME		GetTime;
	LPMAZGETWORKAREA	GetWorkArea;


private:
	HMODULE m_hMAZ;
};