#include "mgc4lz.h"

#pragma once

// CM4lz R}h ^[Qbg
//
//  mgc4lz.dll [hNXł
//	Ver4.1600b
//	
class CM4lz : public CMGC4LZ
{
public:
	CM4lz();
	virtual ~CM4lz();
	
	void LoadDll();
	void UnloadDll();
	int	 AreYouReady();
	int  GetFileVersion(	LPCTSTR lpszFileName,
							DWORD* lpdwMajor,
							DWORD* lpdwMinor,
							DWORD* lpdwRevision,
							DWORD* lpdwBild);

	//
	////  ֐`
	//
	typedef int		(CALLBACK* LPMLZINITIALIZE) (CMGC4LZ::LPINI_PARAMETERS lpParameters);
	typedef UINT	(CALLBACK* LPMLZSTART) (HWND hWnd, CMGC4LZ::LPSTR_PARAMETERS lpParameters);
	typedef int		(CALLBACK* LPMLZSTOP) (HWND hWnd);
	typedef VOID	(CALLBACK* LPMLZGETRESULT) (CMGC4LZ::LPGRT_RESULT lpResult);
	typedef VOID	(CALLBACK* LPMLZGETSAMPLINGPOSITION) (int nNumber, CMGC4LZ::LPGSP_PARAMETERS lpParameters);
	typedef DOUBLE	(CALLBACK* LPMLZDIFFERENTIATE) (CMGC4LZ::LPDIF_PARAMETERS lpParameters);
	typedef	int		(CALLBACK* LPMLZGETFILEVERSION) (	LPCTSTR lpszFileName, 
														DWORD* lpdwMajor, 
														DWORD* lpdwMinor, 
														DWORD* lpdwRevision,
														DWORD* lpdwBild );

	LPMLZINITIALIZE				mlzInitialize;
	LPMLZSTART					mlzStart;
	LPMLZSTOP					mlzStop;
	LPMLZGETRESULT				mlzGetResult;
	LPMLZGETSAMPLINGPOSITION	mlzGetSamplingPosition;
	LPMLZDIFFERENTIATE			mlzDifferentiate;
	LPMLZGETFILEVERSION			mlzGetFileVersion;

private:
	HMODULE m_hMLZ;
};