#pragma once
#include "afx.h"
#include <atlimage.h>

// CMBSE5E R}h ^[Qbg
//
//	mbster5e.dll  Header Ver5.1600a
//
class CMBSE5E : public CObject
{
public:
	//
	//// ʒl
	//
	static const INT mbeTrue = TRUE;
	static const INT mbeFalse = FALSE;
	static const INT null = NULL;
	static const INT yes = TRUE;
	static const INT no = FALSE;
	static const INT maxPath = MAX_PATH;

	static const INT colorRGB = 0;	// ԗΐ
	static const INT colorR = 1;		// 
	static const INT colorG = 2;		// 
	static const INT colorB = 3;		// 
	static const INT colorI = 4;		// Px
	static const INT colorH = 5;		// F
	static const INT colorS = 6;		// ʓx
	static const INT baseColor = 0xf;

	static const INT bpp1 = 1;
	static const INT bpp4 = 4;
	static const INT bpp8 = 8;
	static const INT bpp24 = 24;

	static const ULONG  forImageProsessing		= 0xf0000000;
	static const ULONG  pushInReverseBuffer		= 0x00000000;
	static const ULONG  doNotPushInReverseBuffer= 0x80000000;	// Reverse Buffer  Push Ȃ +Ver1.4 
	static const ULONG  noReverseBuffer			= 0x00000000;	// Do not make revrese buffer	
	static const ULONG  reverseBuffer			= 0x10000000;	// Make revrese Buffer

	//
	//// ߂l
	//
	static const INT success = 0;
	static const INT failure = -1;
	static const INT canceled = 1;

	static const INT errCannotDecolor = -550;	// FłȂ
	static const INT errFile = -551;			// t@CQ
	static const INT errIndexed = -552;			// CfbNXJ[͏łȂ
	static const INT errMemory = -553;			// [s
	static const INT errRva = -554;				// o[Xobt@



	//
	//// ʍ\
	//
	typedef struct  
	{
		LPVOID  lpStack;	// o[Xobt@
		INT		nCount;		// ot@Ă鑍
		INT		nRedo;		// hDł鐔
	} REVERSE_BUFFER, *LPREVERSE_BUFFER;

	typedef struct  
	{
		DWORD	dwR;
		DWORD	dwG;
		DWORD	dwB;
	} COLOR_PALET, *LPCOLOR_PALET;

	typedef struct 	// 摜
	{
		LPVOID				lpImage;
		LPREVERSE_BUFFER	lpReverseBuffer;
	} IMAGEBAG, *LPIMAGEBAG;

	//
	//// \p
	//
	static const INT displayAdjustContrast	= 1;	
	static const INT displayAdjustGamma		= 2;
	static const INT displayAdjustGamma2	= 3;	
	static const INT displayAdjustQuality	= 4;
	static const INT displayCopy			= 5;
	static const INT displayCountColor		= 6;
	static const INT displayDecolor			= 7;
	static const INT displayFilter			= 8;
	static const INT displayGetHistogram	= 9;
	static const INT displayRotate			= 10;

	typedef struct
	{	
		INT		nStatus;
		UINT	nMaxCount;
		UINT	nCount;
		LPVOID	lpParams;
	} DISPLAY_PARAMS, *LPDISPLAY_PARAMS;

	// R[obN֐
	typedef INT CALLBACK DISPLAYFUNCTION(LPDISPLAY_PARAMS lpParams);

	typedef struct
	{	
		DISPLAYFUNCTION* lpFunction;
		LPVOID			 lpParams;
	} DISPLAY_PROCESS, *LPDISPLAY_PROCESS;


	//* mbeCreateImage *//
	// 
	static const ULONG criNoReverseBuffer	= 0x00000000;
	static const ULONG criReverseBuffer		= 0x10000000;	 // + Reverse Buffer


	//* mbeSaveImage *//
	// 
	static const ULONG savType	= 0x00ff;
	static const ULONG savOption = 0xff00;
	static const ULONG savBMP	= 0x0000;
	static const ULONG savGIF	= 0x0002;
	static const ULONG savJPG	= 0x0004;
	static const ULONG savPNG	= 0x0005;
	static const ULONG savTIF	= 0x0006;
	// Options ->	
	static const ULONG savDONT_RENAME = 0x0100;
	// <-

	//* mbeLoadImage *//
	// 
	static const INT ldiNoReverseBuffer = noReverseBuffer;
	static const INT ldiReverseBuffer = reverseBuffer;	 // + Reverse Buffer

	// R[obN֐
	typedef INT CALLBACK JPEGFUNCTION(LPINT lpQuality, const LPVOID lpParams);	// +Ver2.0

	typedef struct	
	{	
		JPEGFUNCTION	*lpFunction;
		LPVOID			lpParams;
	} JPEG_PROCESS, *LPJPEG_PROCESS;


	//* mbeAttachImage *//
	// 
	static const INT atiNoReverseBuffer	= noReverseBuffer;
	static const INT atiReverseBuffer	= reverseBuffer;	 // + Reverse Buffer


	//* mbeGetClipboardImage *//
	// 
	static const INT cpiNoReverseBuffer = noReverseBuffer;
	static const INT cpiReverseBuffer = reverseBuffer;	 // + Reverse Buffer


	//* mbeReverseAction *//
	// 
	static const INT rvaUndo				= 1;
	static const INT rvaRedo				= 2;
	// ߂l
	static const INT rvaAdjustContrast		= 1;
	static const INT rvaAdjustGamma			= 2;
	static const INT rvaAdjustGamma2		= 3;	
	static const INT rvaAdjustQuality		= 4;
	static const INT rvaAttach				= 5;
	static const INT rvaCopy				= 6;
	static const INT rvaDecolor				= 7;	
	static const INT rvaFilter				= 8;	
	static const INT rvaGetClipboardImage	= 9;	
	static const INT rvaLoadImage			= 10;
	static const INT rvaRotate				= 11;

	///
	//////	image processing functions
	//
	//

	//* mbeAdjustContrast *//
	// 
	static const INT adcBaseCOLOR = baseColor;
	static const INT adcR = colorR;		// 
	static const INT adcG = colorG;		// 
	static const INT adcB = colorB;		// 
	static const INT adcRGB	= colorRGB;	// ԗΐ
	static const ULONG adcCommand = 0xff;
	static const ULONG adcAdjustAuto = 0x00;
	static const ULONG adcAdjustManual = 0x01;
	static const ULONG adcAdjustSpot = 0x02;

	// \
	typedef struct
	{
		INT nLevel; 
		INT nBaseColor;
		INT nLeft;
		INT nTop;
		INT nRight;
		INT nBottom;
	} ADC_ADJUSTMENT, *LPADC_ADJUSTMENT;


	//* mbeAdjustGamma *//
	// 
	static const INT adgR = colorRGB;		// 
	static const INT adgG = colorG;			// 
	static const INT adgB = colorB;			// 
	static const INT adgRGB = colorRGB;		// ԗΐ
	static const ULONG adgConstantI = 0x100;	// Px

	// \
	typedef struct
	{
		DOUBLE nGamma;
		INT	   nBaseColor;
		INT	   nLeft;
		INT	   nTop;
		INT	   nRight;
		INT	   nBottom;
	} ADG_ADJUSTMENT, *LPADG_ADJUSTMENT;


	//* mbeAdjustGamma2 *//
	// \
	typedef struct 
	{
		BYTE   szMappingData[256];
		INT	   nBaseColor;
		INT	   nLeft;
		INT	   nTop;
		INT	   nRight;
		INT	   nBottom;
	} ADG_ADJUSTMENT2, *LPADG_ADJUSTMENT2;


	//* mbeAdjustQuality *//
	// 
	static const ULONG adqCOmmand			= 0x000000ff;
	static const ULONG adqOptions			= 0xffffff00;
	static const ULONG adqCmdQuality		= 0x00000000;
	static const ULONG adqOptAll			= 0x00000000;
	static const ULONG adqOptFarDistance	= 0x00000100;

	// \
	typedef struct
	{
		INT		nHeu; 
		INT		nIntensity;
		INT		nSaturation;
		DWORD	dwColor;
		INT		nColorDistance;
		INT		nLeft;
		INT		nTop;
		INT		nRight;
		INT		nBottom;
	} ADQ_ADJUSTMENT, *LPADQ_ADJUSTMENT;


	//* mbeCopy *// 
	// 
	static const ULONG cpyCommand		= 0x0000000ff;
	static const ULONG cpyOption		= 0x0ffffff00;
	static const ULONG cpyCopy			= 0x000000000;
	static const ULONG cpyAnd			= 0x000000001;	// AND COPY +Ver2.0
	static const ULONG cpyOr			= 0x000000002;	// OR  COPY +Ver2.0
	static const ULONG cpyXor			= 0x000000003;	// XOR COPY +Ver2.0
	static const ULONG cpyGetSize		= 0x000000004;	// TCY擾
	static const ULONG cpyMHQ			= 0x000000000;	// gkRs[i High +Ver2.0
	static const ULONG cpyMLQ			= 0x000000100;	// gkRs[i Low@+Ver2.0
	static const ULONG cpyMirror		= 0x000000200;	// ~[]   +Ver1.4
	static const ULONG cpyReverseColor	= 0x000000400;	// F̃rbg] +Ver1.4
	static const ULONG cpySepia			= 0x000000800;	// ZsAJ[   +Ver1.4

	static const ULONG cpyNoReverseBuffer = noReverseBuffer;
	static const ULONG cpyReverseBuffer = reverseBuffer;	// + Reverse Buffer


	// \
	typedef struct 
	{
		INT		nSrcLeft;		// \[XʒuTCY
		INT		nSrcTop;
		INT		nSrcRight;
		INT		nSrcBottom;
		INT		nBitPerPixel;	// F
		INT		nDegrees;		// ]p
		FLOAT	nMagX;			// {
		FLOAT	nMagY;		
		INT		nDestX;			// o͈ʒuTCY
		INT		nDestY;
		INT		nDestWidth;	
		INT		nDestHeight;	
	} CPY_PARAMS, *LPCPY_PARAMS;


	//* mbeDecolor *//
	static const ULONG decVALUE			= 0x000000ff;  // l
	static const ULONG decMode			= 0x0000ff00;
	static const ULONG decModeColor		= 0x00000100;	// 24bit
	static const ULONG decModeLevel		= 0x00000200;	// Level
	static const ULONG decModeMedianCut = 0x00000300;	// fBAJbg@(œK)
	static const ULONG decModeBinary	= 0x00000400;	// 1bit
	static const ULONG decBase			= 0x000f0000;
	static const ULONG decBaseRGB		= 0x00000000;	// ϓ
	static const ULONG decBaseR			= 0x00010000;	// 
	static const ULONG decBaseG			= 0x00020000;	// 
	static const ULONG decBaseB			= 0x00030000;	// 
	static const ULONG decBaseI			= 0x00040000;	// Px
	static const ULONG decOption		= 0x0ff00000;
	static const ULONG decOp666			= 0x00000000;	// 8bit(6,6,6)
	static const ULONG decOp884			= 0x00100000;	// 8bit(8,4,4)
	static const ULONG decOp667			= 0x00200000;	// 8bit(6,6,7)
	static const ULONG decOpColor		= 0x00000000;
	static const ULONG decOpGray		= 0x00400000;
	static const ULONG decOpNoneNoise	= 0x00000000;	// decMode_BINARY p mCYȂ
	static const ULONG decOpMakeNoise	= 0x00100000;	// decMode_BINARY p mCYt


	//* mbeRotate *//
	static const INT rotMHQ	= cpyMHQ;
	static const INT rotMLQ = cpyMLQ;

	typedef struct 
	{
		INT nDegrees;		// ]p
	} ROT_PARAMS, *LPROT_PARAMS;


	//* mbeFilter *//
	// 
	static const ULONG fltFilter			= 0x0000000f;
	static const ULONG fltType				= 0x00000fff;
	static const ULONG fltOptions			= 0x0ffff000;

	static const ULONG fltHighpass			= 0x00000000;
	static const ULONG fltLowpass			= 0x00000001;

	// HighpassFilter
	// 
	static const ULONG fltPrewitX		= 0x00000000;
	static const ULONG fltPrewitY		= 0x00000010;
	static const ULONG fltPrewitXY		= 0x00000020;
	static const ULONG fltSobelX		= 0x00000030;
	static const ULONG fltSobelY		= 0x00000040;
	static const ULONG fltSobelXY		= 0x00000050;
	static const ULONG fltSharpening1	= 0x00000060;
	static const ULONG fltSharpening2	= 0x00000070;
	static const ULONG fltSharpening3	= 0x00000080;
	static const ULONG fltSharpening4	= 0x00000090;
	static const ULONG fltSharpening5	= 0x000000a0;
	static const ULONG fltSharpening6	= 0x000000b0;
	static const ULONG fltSharpening7	= 0x000000c0;
	static const ULONG fltSharpening8	= 0x000000d0;
	static const ULONG fltCustom		= 0x00000ff0;
	// Option
	static const ULONG fltColor			= 0x00000000;
	static const ULONG fltReverse		= 0x00001000;
	static const ULONG fltGray			= 0x00002000;
	static const ULONG fltBlackWhite32	= 0x00004000;	
	static const ULONG fltBlackWhite64	= 0x00008000;
	static const ULONG fltBlackWhite128	= 0x00010000;
	static const ULONG fltBlackWhite160	= 0x00020000;
	static const ULONG fltBlackWhite192	= 0x00040000;
	static const ULONG fltBlackWhite224	= 0x00080000;
	// LowpassFilter
	// 
	static const ULONG fltMedianFilter		= 0x00000001;
	static const ULONG fltMoovingAverage1	= 0x00000011;
	static const ULONG fltMoovingAverage2	= 0x00000021;
	static const ULONG fltMoovingAverage3	= 0x00000031;
	static const ULONG fltMoovingAverage4	= 0x00000041;

	// \
	typedef struct
	{	
		INT	 nFilter[5][5];	// tB^
		INT	 nOrdinal;		// tB^̏
		INT	 nOffset;		// F̃ItZbg
		BOOL bXY;			// wƂx܂߂
	} FLT_CUSTOM_DATA, *LPFLT_CUSTOM_DATA;

	typedef struct 
	{
		INT	nLeft;
		INT	nTop;
		INT	nRight;
		INT	nBottom;
		FLT_CUSTOM_DATA CustomData;
	} FLT_ADJUSTMENT, *LPFLT_ADJUSTMENT;


	//* mbeGetHistogram *//
	// \
	// nHist[hstR][] ͐ nHist[hstG][]͗ ȉ hst* ƓSUF nPeakDensity 
	// 
	static const INT hstR	= 0;   // 
	static const INT hstG	= 1;   // 
	static const INT hstB	= 2;   // 
	static const INT hstI	= 3;	// Px
	static const INT hstH	= 4;	// F
	static const INT hstS	= 5;	// ʓx

	typedef struct _hstHISTOGRAM
	{
		INT nData[6][256]; 
		INT nPeakDensity[6];
		INT nMaximum[6];
		INT nBitPerPixel;
	} HST_HISTOGRAM, *LPHST_HISTOGRAM;

};