#pragma once
#include "afx.h"
#include "twain.h"

// CMGC4E R}h ^[Qbg
//
//	mgc4e.dll  Header Ver4.1600a
//
class CMGC4E : public CObject
{
public:
	//  萔
	static const INT eTrue = TRUE;
	static const INT eFalse = FALSE;
	static const INT yes = TRUE;
	static const INT no = FALSE;
	static const INT null = NULL;
	static const INT maxPath = MAX_PATH;

	// meOpenSource
	static const ULONG osoSourceManeger		= 0x00000001;  // Open data source maneger
	static const ULONG osoSource			= 0x00000002;  // Open data source
	static const ULONG osoCheckTurningOn	= 0x00010000;  // Check turning on
	static const ULONG osoShowErrorMessage	= 0x00020000;  // Show message dialog
	static const ULONG osoAuto3				= osoSource | osoSourceManeger;
	static const ULONG osoAuto2				= osoAuto3 | osoShowErrorMessage;
	static const ULONG osoAuto1				= osoAuto2 | osoCheckTurningOn;

	static const INT osoTurningOff = 1000;

	// meCloseSource
	static const ULONG csoAuto				= osoAuto2;
	static const ULONG csoSourceMameger		= osoSourceManeger;
	static const ULONG csoSource			= osoSource;
	static const ULONG csoShowErrorMessage	= osoShowErrorMessage;


	// meRequestAcquisition
	static const ULONG rqaTmCommand	= 0x000000ff;
	static const ULONG rqaTmNative	= 0x00000000;
	static const ULONG rqaTmMemory	= 0x00000001;
	static const ULONG rqaTmDisk	= 0x00000002;
	static const ULONG rqaUiShow	= 0x00000000;
	static const ULONG rqaUiHide	= 0x00000100;

	static const ULONG rqaTimeOutNo	= 0xf0000000;
	static const ULONG rqaTimeOut0	= 0x00000000;
	static const ULONG rqaTimeOut1	= 0x10000000;
	static const ULONG rqaTimeOut2	= 0x20000000;
	static const ULONG rqaTimeOut3	= 0x30000000;
	static const ULONG rqaTimeOut4	= 0x40000000;
	static const ULONG rqaTimeOut5	= 0x50000000;
	static const ULONG rqaTimeOut6	= 0x60000000;
	static const ULONG rqaTimeOut7	= 0x70000000;
	static const ULONG rqaTimeOut8	= 0x80000000;
	static const ULONG rqaTimeOut9	= 0x90000000;
	static const ULONG rqaTimeOutA	= 0xa0000000;
	static const ULONG rqaTimeOutB	= 0xb0000000;
	static const ULONG rqaTimeOutC	= 0xc0000000;
	static const ULONG rqaTimeOutD	= 0xd0000000;
	static const ULONG rqaTimeOutE	= 0xe0000000;

	typedef BOOL CALLBACK MEDLGFUNCTION(	const	LPVOID	lpParams, 
													UINT	nMaxSize, 
													UINT	nWrittenSize, 
											const	LPCTSTR lpszText		);

	typedef struct	// R[obN֐pf[^
	{		
		MEDLGFUNCTION	*lpFunction;		// R[obN֐
		LPVOID			lpParams;			// Cӂ̃|C^
		UINT			nMaxSize;			// 鑍oCg
		UINT			nWrittenSize;		// oCg
		WCHAR			szText[maxPath];	// Cӂ̕
	} RQA_DLG_PARAMS, *LPRQA_DLG_PARAMS;

	// meXfers
	static const INT xfrContinue	= 0;				// ǎp
	static const INT xfrAborted		= 1;				// rI
	static const INT xfrEnd			= xfrAborted;
	static const INT xfrDone		= 2;				// ǎ芮Aǉ摜
	static const INT xfrFinished	= 3;				// ǎ芮Aǉ摜Ȃ
	static const INT xfrLast		= xfrFinished;
	static const INT xfrTimeOut		= 4;				// Ԑ؂I

	// meGetCapability & meSetCapability
	static const INT capRangeMin		= 0;
	static const INT capRangeMax		= 1;
	static const INT capRangeStepSize	= 2;
	static const INT capDefault			= 3;
	static const INT capCurrent			= 4;
	static const INT capMaxArray		= 512;

	// meSaveImage
	static const INT sivDontOverWrite	= 0;
	static const INT sivCreateFile		= 1;

	// meGetWindowsDirectory
	static const INT gwdWindowsDirectory	= 0;
	static const INT gwdSystemDirectory		= 1;

};