Option Strict On
Option Explicit On
Module mgc4e
    '
    ' m.magic E DLL Header Ver4.1600a
    '
    '  (C) m.magic & K Maruyama. All rights reserved.


    '//  萔
    Public Const meTrue As Integer = 1
    Public Const meFalse As Integer = 0
    Public Const meYes As Integer = 1
    Public Const meNo As Integer = 0
    Public Const meNull As Integer = 0
    Public Const meMaxPath As Integer = 259

    '// meOpenSource
    Public Const meOsoSourceManeger As Integer = &H1  '// Open data source maneger
    Public Const meOsoSource As Integer = &H2          '// Open data source
    Public Const meOsoCheckTurningOn As Integer = &H10000    '// Check turning on
    Public Const meOsoShowErrorMessage As Integer = &H20000        '// Show message dialog
    Public Const meOsoAuto3 As Integer = meOsoSource Or meOsoSourceManeger
    Public Const meOsoAuto2 As Integer = meOsoAuto3 Or meOsoShowErrorMessage
    Public Const meOsoAuto1 As Integer = meOsoAuto2 Or meOsoCheckTurningOn

    Public Const meOsoTURNING_OFF As Integer = 1000

    '// meCloseSource
    Public Const meCsoAuto As Integer = meOsoAuto2
    Public Const meCsoSourceManeger As Integer = meOsoSourceManeger
    Public Const meCsoSource As Integer = meOsoSource
    Public Const meCsoShowErrorMessage As Integer = meOsoShowErrorMessage


    '// meRequestAcquisition
    Public Const meRqaTmCommand As Integer = &HFF
    Public Const meRqaTmNative As Integer = &H0
    Public Const meRqaTmMemory As Integer = &H1
    Public Const meRqaTmDisk As Integer = &H2
    Public Const meRqaUiShow As Integer = &H0
    Public Const meRqaUiHide As Integer = &H100

    Public Const meRqaTimeoutNo As Integer = &HF0000000
    Public Const meRqaTimeout0 As Integer = &H0
    Public Const meRqaTimeout1 As Integer = &H10000000
    Public Const meRqaTimeout2 As Integer = &H20000000
    Public Const meRqaTimeout3 As Integer = &H30000000
    Public Const meRqaTimeout4 As Integer = &H40000000
    Public Const meRqaTimeout5 As Integer = &H50000000
    Public Const meRqaTimeout6 As Integer = &H60000000
    Public Const meRqaTimeout7 As Integer = &H70000000
    Public Const meRqaTimeout8 As Integer = &H80000000
    Public Const meRqaTimeout9 As Integer = &H90000000
    Public Const meRqaTimeoutA As Integer = &HA0000000
    Public Const meRqaTimeoutB As Integer = &HB0000000
    Public Const meRqaTimeoutC As Integer = &HC0000000
    Public Const meRqaTimeoutD As Integer = &HD0000000
    Public Const meRqaTimeoutE As Integer = &HE0000000

    '// R[obN֐
    Public Delegate Function MECALLBACKFUNCTION(ByRef pDialog As IntPtr, _
                                                ByVal maxSize As Integer, _
                                                ByVal writtenSize As Integer, _
                                                ByVal text As String) As Integer

    Structure ME_RQA_DLG_PARAMS '// R[obN֐pf[^ 
        Dim callbackFunction As MECALLBACKFUNCTION      '// R[obN֐
        Dim params As Integer                           '// _CAÕ|C^
        Dim maxSize As Integer                          '// 鑍oCg
        Dim writtenSize As Integer                      '// oCg
        <VBFixedString(meMaxPath), _
        System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=meMaxPath)> _
        Public text As String '// Cӂ̕
    End Structure


    '// meXfers
    Public Const meXfrContinue As Integer = 0     '// ǎp
    Public Const meXfrAborted As Integer = 1      '// I
    Public Const meXfrEnd As Integer = meXfrAborted
    Public Const meXfrDone As Integer = 2         '// ǎ芮Aǉ摜
    Public Const meXfrFinished As Integer = 3     '// ǎ芮Aǉ摜Ȃ
    Public Const meXfrLast As Integer = meXfrFinished
    Public Const meXfrTimeOut As Integer = 4      '// Ԑ؂

    '// meGetCapability & meSetCapability
    Public Const meCapRangeMin As Integer = 0
    Public Const meCapRangeMax As Integer = 1
    Public Const meCapRangeStep As Integer = 2
    Public Const meCapMaxArray As Integer = 511

    '// meSaveImage
    Public Const meSviDontOverWrite As Integer = 0
    Public Const meSviCreateFile As Integer = 1

    '// meGetWindowsDirectory
    Public Const meGwdWindowsDirectory As Integer = 0
    Public Const meGwdSystemDirectory As Integer = 1


    '^
    Structure POINTAPI
        Dim x As Integer
        Dim y As Integer
    End Structure

    Structure MSG
        Dim pWnd As IntPtr
        Dim message As Integer
        Dim wParam As Integer
        Dim lParam As Integer
        Dim time As Integer
        Dim pt As POINTAPI
    End Structure

    Structure RECT
        Dim left As Integer
        Dim top As Integer
        Dim right As Integer
        Dim bottom As Integer
    End Structure


    '//
    '//// TWAIN
    '//

    '// ڑ
    Public Declare Unicode Function _
    meCloseSource Lib "mgc4e.dll" (ByVal functions As Integer, _
                                     ByVal pWnd As IntPtr) As Integer
    Public Declare Unicode Function _
    meConnectTwainSession Lib "mgc4e.dll" (ByRef twAppID As TW_IDENTITY, _
                                             ByVal szSMDir As String) As Integer
    Public Declare Unicode Function _
    meDisconnectTwainSession Lib "mgc4e.dll" () As Integer
    Public Declare Unicode Function _
    meOpenSource Lib "mgc4e.dll" (ByVal functions As Integer, _
                                    ByVal pWnd As IntPtr) As Integer
    Public Declare Unicode Function _
    meRequestAcquisition Lib "mgc4e.dll" (ByVal functions As Integer, _
                                            ByVal pWnd As IntPtr, _
                                            ByRef params As Integer) As Integer
    Public Declare Unicode Function _
    meRequestAcquisition Lib "mgc4e.dll" (ByVal functions As Integer, _
                                            ByVal pWnd As IntPtr, _
                                            ByRef dlgProcParams As ME_RQA_DLG_PARAMS) As Integer
    Public Declare Unicode Function _
    meRequestAcquisition Lib "mgc4e.dll" (ByVal functions As Integer, _
                                            ByVal pWnd As IntPtr, _
                                            ByVal fileName As String) As Integer
    Public Declare Unicode Function _
    meXfers Lib "mgc4e.dll" () As Integer

    '// 
    Public Declare Unicode Function _
    meGetTwainState Lib "mgc4e.dll" () As Short

    '// 擾
    Public Declare Unicode Function _
    meGetAppID Lib "mgc4e.dll" (ByRef twAppID As TW_IDENTITY) As Integer

    '// \[X
    Public Declare Unicode Function _
    meEnumerateSource Lib "mgc4e.dll" (ByVal reset As Integer) As Integer
    Public Declare Unicode Function _
    meGetDefaultSource Lib "mgc4e.dll" (ByRef sourceID As TW_IDENTITY) As Integer
    Public Declare Unicode Function _
    meGetSourceID Lib "mgc4e.dll" (ByRef sourceID As TW_IDENTITY) As Integer
    Public Declare Unicode Function _
    meSelectSource Lib "mgc4e.dll" () As Integer
    Public Declare Unicode Function _
    meSetSourceID Lib "mgc4e.dll" (ByRef sourceID As TW_IDENTITY) As Integer


    '//
    '//// @\
    '//

    '// Capability
    Public Declare Unicode Function _
    meGetCapability Lib "mgc4e.dll" (ByVal twMsg As Short, _
                                        ByVal twCap As Short, _
                                        ByRef twConType As Short, _
                                        ByRef twItemType As Short, _
                                        ByVal capsArray() As Integer, _
                                        ByRef twMaxSize As Integer, _
                                        ByVal errorMessage As Integer) As Integer
    Public Declare Unicode Function _
    meGetCapability Lib "mgc4e.dll" (ByVal twMsg As Short, _
                                        ByVal twCap As Short, _
                                        ByRef twConType As Short, _
                                        ByRef twItemType As Short, _
                                        ByVal capsArray() As Short, _
                                        ByRef twMaxSize As Integer, _
                                        ByVal errorMessage As Integer) As Integer
    Public Declare Unicode Function _
    meGetCapability Lib "mgc4e.dll" (ByVal twMsg As Short, _
                                        ByVal twCap As Short, _
                                        ByRef twConType As Short, _
                                        ByRef twItemType As Short, _
                                        ByVal capsArray() As Single, _
                                        ByRef twMaxSize As Integer, _
                                        ByVal errorMessage As Integer) As Integer

    Public Declare Unicode Function _
    meGetDefaultImageLayout Lib "mgc4e.dll" (ByRef twImageLayout As TW_IMAGELAYOUT) As Integer
    Public Declare Unicode Function _
    meGetImageLayout Lib "mgc4e.dll" (ByRef twImageLayout As TW_IMAGELAYOUT) As Integer
    Public Declare Unicode Function _
    meGetResolution Lib "mgc4e.dll" (ByVal twMsg As Short, _
                                        ByRef xResolution As Single, _
                                        ByRef yResolution As Single) As Integer

    Public Declare Unicode Function _
    meSetCapability Lib "mgc4e.dll" (ByVal twMsg As Short, _
                                        ByVal twCap As Short, _
                                        ByVal twConType As Short, _
                                        ByVal twItemType As Short, _
                                        ByVal capsArray() As Integer, _
                                        ByVal twMaxSize As Integer, _
                                        ByVal errorMessage As Integer) As Integer
    Public Declare Unicode Function _
    meSetCapability Lib "mgc4e.dll" (ByVal twMsg As Short, _
                                        ByVal twCap As Short, _
                                        ByVal twConType As Short, _
                                        ByVal twItemType As Short, _
                                        ByVal capsArray() As Short, _
                                        ByVal twMaxSize As Integer, _
                                        ByVal errorMessage As Integer) As Integer
    Public Declare Unicode Function _
    meSetCapability Lib "mgc4e.dll" (ByVal twMsg As Short, _
                                        ByVal twCap As Short, _
                                        ByVal twConType As Short, _
                                        ByVal twItemType As Short, _
                                        ByVal capsArray() As Single, _
                                        ByVal twMaxSize As Integer, _
                                        ByVal errorMessage As Integer) As Integer

    Public Declare Unicode Function _
    meSetImageLayout Lib "mgc4e.dll" (ByRef twImageLayouhfdt As TW_IMAGELAYOUT) As Integer
    Public Declare Unicode Function _
    meSetResolution Lib "mgc4e.dll" (ByVal twMsg As Short, _
                                        ByVal xResolution As Single, _
                                        ByVal yResolution As Single) As Integer
    Public Declare Unicode Function _
    meShowDlgCaps Lib "mgc4e.dll" (ByVal title As String, _
                                        ByVal pWnd As IntPtr, _
                                        ByVal errorMessage As Integer) As Integer


    '//
    '//// ǎ摜
    '//
    Public Declare Unicode Function _
    meGetImage Lib "mgc4e.dll" () As IntPtr
    Public Declare Unicode Function _
    meGetImageInfo Lib "mgc4e.dll" (ByRef imageInfo As TW_IMAGEINFO) As Integer
    Public Declare Unicode Function _
    meDestroyImage Lib "mgc4e.dll" () As Integer
    Public Declare Unicode Function _
    meSetImage Lib "mgc4e.dll" (ByVal pBitmap As IntPtr) As IntPtr


    '//
    '//// ̑
    '//

    '// Pʕϊ
    Public Declare Unicode Function _
    meFIX32ToFloat Lib "mgc4e.dll" (ByRef twFix32 As TW_FIX32) As Single
    Public Declare Unicode Function _
    meFloatToFIX32 Lib "mgc4e.dll" (ByVal float As Single) As TW_FIX32
    Public Declare Unicode Function _
    meInchToMM Lib "mgc4e.dll" (ByVal inch As Single) As Single
    Public Declare Unicode Function _
    meInchToTwips Lib "mgc4e.dll" (ByVal inch As Single) As Integer
    Public Declare Unicode Function _
    meMMtoInch Lib "mgc4e.dll" (ByVal mm As Single) As Single
    Public Declare Unicode Function _
    meMMToTwips Lib "mgc4e.dll" (ByVal mm As Single) As Integer
    Public Declare Unicode Function _
    meTwipsToInch Lib "mgc4e.dll" (ByVal twips As Integer) As Single
    Public Declare Unicode Function _
    meTwipsToMM Lib "mgc4e.dll" (ByVal twips As Integer) As Single

    '// 摜
    Public Declare Unicode Function _
    meGetClipbordDIB Lib "mgc4e.dll" (ByVal pWnd As IntPtr) As Integer
    Public Declare Unicode Function _
    meGetDIBSize Lib "mgc4e.dll" (ByRef height As Integer, ByRef width As Integer) As Integer
    Public Declare Unicode Function _
    meLoadImage Lib "mgc4e.dll" (ByVal fileName As String, ByRef pReserved As IntPtr) As Integer
    Public Declare Unicode Function _
    mePaintDIB Lib "mgc4e.dll" (ByVal pDC As IntPtr, _
                                    ByRef DCRect As RECT, _
                                    ByRef DIBRect As RECT) As Integer
    Public Declare Unicode Function _
    meSaveImage Lib "mgc4e.dll" (ByVal fileName As String, ByVal mode As Integer) As Integer
    Public Declare Unicode Function _
    meSetClipbordDIB Lib "mgc4e.dll" (ByVal pWnd As IntPtr) As Integer

    '// ̑
    Public Declare Unicode Function _
    meCaptureButton Lib "mgc4e.dll" (ByVal pWnd As IntPtr) As Integer
    Public Declare Unicode Function _
    meGetFileVersion Lib "mgc4e.dll" (ByVal fileName As String, _
                                        ByRef major As Integer, _
                                        ByRef minor As Integer, _
                                        ByRef revision As Integer, _
                                        ByRef build As Integer) As Integer

End Module